'THIS SDK IS FOR APPFORGE .NET CROSSFIRE ONLY

Option Strict Off
Option Explicit On 
Imports System.Runtime.InteropServices
Module AppForgePPSDK

    'true/false constants
    Public Const DPTRUE As Short = 1
    Public Const DPFALSE As Short = 0

    'underline modes
    Public Const PRNnoUnderline As Short = 0
    Public Const PRNgrayUnderline As Short = 1
    Public Const PRNsolidUnderline As Short = 2
    Public Const PRNcolorUnderline As Short = 3

    'palmos standart fonts
    Public Const PRNstdFont As Short = 0
    Public Const PRNboldFont As Short = 1
    Public Const PRNlargeFont As Short = 2
    Public Const PRNsymbolFont As Short = 3
    Public Const PRNsymbol11Font As Short = 4
    Public Const PRNsymbol7Font As Short = 5
    Public Const PRNledFont As Short = 6
    Public Const PRNlargeBoldFont As Short = 7
    Public Const PRNfntAppFontCustomBase As Short = 128

    'GetLibraryInfo params
    Public Const INFO_RELEASE As Short = 0
    Public Const INFO_BUILD As Short = 1
    Public Const INFO_STAGE As Short = 2
    Public Const INFO_ISDEBUG As Short = 3

    'GetLibraryInfo stage values
    Public Const STAGE_PREVIEW As Short = 0
    Public Const STAGE_ALPHA As Short = 1
    Public Const STAGE_BETA As Short = 2
    Public Const STAGE_GAMMA As Short = 3
    Public Const STAGE_RC As Short = 4
    Public Const STAGE_FINAL As Short = 5

    'Printer Types
    Public Const PP50 As Short = 0
    Public Const PP55 As Short = 1
    Public Const CMP10 As Short = 2

    'Connection Types
    Public Const CONSERIAL As Short = 0
    Public Const CONUSB As Short = 1

    'Speed Settings
    Public Const Speed1200 As Short = 0
    Public Const Speed2400 As Short = 1
    Public Const Speed4800 As Short = 2
    Public Const Speed9600 As Short = 3
    Public Const Speed19200 As Short = 4
    Public Const Speed38400 As Short = 5
    Public Const Speed57600 As Short = 6
    Public Const Speed115200 As Short = 7

    'Intensity Levels
    Public Const Intensity70 As Short = 0
    Public Const Intensity80 As Short = 1
    Public Const Intensity90 As Short = 2
    Public Const Intensity100 As Short = 3
    Public Const Intensity120 As Short = 4
    Public Const Intensity150 As Short = 5

    'Internal Font Types
    Public Const FontLarge As Short = 0
    Public Const FontSmall As Short = 1

    'Print Barcode Types
    Public Const Bar_UPCA As Short = 0
    Public Const Bar_UPCE As Short = 1
    Public Const Bar_EAN13 As Short = 2
    Public Const Bar_EAN8 As Short = 3
    Public Const Bar_CODE39 As Short = 4
    Public Const Bar_ITF As Short = 5
    Public Const Bar_CODABAR As Short = 6
    Public Const Bar_CODE93 As Short = 7
    Public Const Bar_CODE128 As Short = 8
    Public Const Bar_PDF417 As Short = 9

    'GetStatus commands
    Public Const STAT_ISCONNECTED As Short = 0
    Public Const STAT_GETBATVOLT As Short = 1
    Public Const STAT_GETBATPERCENT As Short = 2
    Public Const STAT_GETTEMPC As Short = 3
    Public Const STAT_GETTEMPFR As Short = 4
    Public Const STAT_HASPAPER As Short = 5
    Public Const STAT_GETVERSION As Short = 6
    Public Const STAT_GETTYPE As Short = 7
    Public Const STAT_GETCONNECTION As Short = 8
    Public Const STAT_GETSPEED As Short = 9

    'GetStatus result codes
    Public Const StatErrNotImpl As Short = -1
    Public Const StatErrNotConnected As Short = -2

    'Barcode Parameters
    Public Const BeeperTone As Short = &H91S
    Public Const SessionTime As Short = &H88S
    Public Const BeepAfterGoodDecode As Short = &H38S
    Public Const LinearCodeTypeSecurityLevel As Short = &H4ES
    Public Const EnableUPCA As Short = &H1S
    Public Const EnableUPCE As Short = &H2S
    Public Const EnableUPCE1 As Short = &HCS
    Public Const EnableEAN8 As Short = &H4S
    Public Const EnableEAN13 As Short = &H3S
    Public Const EnableBooklandEAN As Short = &H53S
    Public Const TransmitUPCACheckDigit As Short = &H28S
    Public Const TransmitUPCECheckDigit As Short = &H29S
    Public Const TransmitUPCE1CheckDigit As Short = &H2AS
    Public Const UPCAPreamble As Short = &H22S
    Public Const UPCEPreamble As Short = &H23S
    Public Const UPCE1Preamble As Short = &H24S
    Public Const ConvertUPCEtoA As Short = &H25S
    Public Const ConvertUPCE1toA As Short = &H26S
    Public Const EAN8ZeroExtend As Short = &H27S
    Public Const ConvertEAN8toEAN13 As Short = &HE0S
    Public Const UPCEANSecurityLevel As Short = &H4DS
    Public Const UPCEANCouponCode As Short = &H55S
    Public Const EnableCode128 As Short = &H8S
    Public Const EnableUCCEAN128 As Short = &HES
    Public Const EnableCode39 As Short = &H0S
    Public Const EnableTriopticCode39 As Short = &HDS
    Public Const ConvertCode39toCode32 As Short = &H56S
    Public Const TransmitCode39CheckDigit As Short = &H2BS
    Public Const Code39FullASCIIConversion As Short = &H11S
    Public Const EnableCode93 As Short = &H9S
    Public Const EnableInterleaved2of5 As Short = &H6S
    Public Const TransmitI2of5CheckDigit As Short = &H2CS
    Public Const ConvertI2of5toEAN13 As Short = &H52S
    Public Const EnableDiscrete2of5 As Short = &H5S
    Public Const EnableCodabar As Short = &H7S
    Public Const EnableMSIPlessey As Short = &HBS
    Public Const TransmitMSIPlesseyCheckDigit As Short = &H2ES
    Public Const EnableCode11 As Short = &HAS
    Public Const EnableWebcode As Short = &HF076S
    Public Const EnableGTWebcode As Short = &HF079S

    'Barcode Types
    Public Const Bookland As Short = &H16S
    Public Const Codabar As Short = &H2S
    Public Const Code11 As Short = &HCS
    Public Const Code32 As Short = &H20S
    Public Const Code128 As Short = &H3S
    Public Const Code39 As Short = &H1S
    Public Const Code39_FullASCII As Short = &H13S
    Public Const Code93 As Short = &H7S
    Public Const Composite As Short = &H1DS
    Public Const Coupon As Short = &H17S
    Public Const D25 As Short = &H4S
    Public Const DataMatrix As Short = &H1BS
    Public Const EAN_128 As Short = &HFS
    Public Const EAN_13 As Short = &HBS
    Public Const EAN_13_plus_2 As Short = &H4BS
    Public Const EAN_13_plus_5 As Short = &H8BS
    Public Const EAN_8 As Short = &HAS
    Public Const EAN_8_plus_2 As Short = &H4AS
    Public Const EAN_8_plus_5 As Short = &H8AS
    Public Const IATA As Short = &H5S
    Public Const ISBT_128 As Short = &H19S
    Public Const ISBT_128_concateneted As Short = &H21S
    Public Const ITF As Short = &H6S
    Public Const MacroPDF As Short = &H28S
    Public Const MSI As Short = &HES
    Public Const PDF_417 As Short = &H11S
    Public Const Postbar_Canada As Short = &H26S
    Public Const Postnet_US As Short = &H1ES
    Public Const Postal_Australia As Short = &H23S
    Public Const Postal_Japan As Short = &H22S
    Public Const Postal_UK As Short = &H27S
    Public Const QR_code As Short = &H1CS
    Public Const RSS_limited As Short = &H31S
    Public Const RSS_14 As Short = &H30S
    Public Const RSS_Expanded As Short = &H32S
    Public Const Signature As Short = &H24S
    Public Const TriopticCode39 As Short = &H15S
    Public Const UPCA As Short = &H8S
    Public Const UPCA_plus_2 As Short = &H48S
    Public Const UPCA_plus_5 As Short = &H88S
    Public Const UPCE As Short = &H9S
    Public Const UPCE_plus_2 As Short = &H49S
    Public Const UPCE_plus_5 As Short = &H89S
    Public Const UPCE1 As Short = &H10S
    Public Const UPCE1_plus_2 As Short = &H50S
    Public Const UPCE1_plus_5 As Short = &H90S

    'Barcode Functions Result codes
    Public Const PPBarErrNone As Short = 0
    Public Const PPBarErrNoBar As Short = 1
    Public Const PPBarErrFailed As Short = 2
    Public Const PPBarErrWrongArguments As Short = 3

    'ResetDefaults Flags
    Public Const Reset_PrintSettings As Short = 1
    Public Const Reset_FontSettings As Short = 2
    Public Const Reset_BarcodeSettings As Short = 4
    Public Const Reset_DontSetPrinter As Short = &H80S

    'PrintTextEx Flags
    Public Const Text_Italic As Short = 1
    Public Const Text_Bold As Short = 2
    Public Const Text_Underlined As Short = 4
    Public Const Text_DoubleWidth As Short = 8
    Public Const Text_DoubleHeight As Short = 16
    Public Const Text_Rotated As Short = 32
    Public Const Text_Reversed As Short = 64

    Public Const Text_AlignMask As Short = 512 + 256
    Public Const Text_AlignLeft As Short = 0
    Public Const Text_AlignCenter As Short = 256
    Public Const Text_AlignRight As Short = 512

    Public Const Text_BigFont As Short = 0
    Public Const Text_SmallFont As Short = 1024

    Public Const Text_DontLF As Short = 2048
    Public Const Text_WordWrap As Short = 4096

    Public Const Text_UseOldSettings As Short = 8192
    Public Const Text_SaveSettings As Short = 16384

    'TABLE DEFINES
    'Table - Column flags
    Public Const COL_BOLD As Short = 1
    Public Const COL_ITALIC As Short = 2
    Public Const COL_SMALL As Short = 4
    Public Const COL_UNDERLINE As Short = 8
    Public Const COL_DOUBLWIDTH As Short = 16
    Public Const COL_DOUBLHEIGHT As Short = 32
    Public Const COL_INVERT As Short = 64

    Public Const COL_ALIGN_MASK As Short = 768
    Public Const COL_LEFT As Short = 0
    Public Const COL_CENTER As Short = 256
    Public Const COL_RIGHT As Short = 512

    Public Const COL_BORIN As Short = 16

    'Table - Row flags
    Public Const ROW_BORLEFT As Short = 1
    Public Const ROW_BORINH As Short = 2
    Public Const ROW_BORINV As Short = 4
    Public Const ROW_BORRIGHT As Short = 8
    Public Const ROW_BORTOP As Short = 16
    Public Const ROW_BORBOTTOM As Short = 32
    Public Const ROW_BORALL As Double = ROW_BORLEFT + ROW_BORINV + ROW_BORRIGHT + ROW_BORTOP + ROW_BORBOTTOM
    Public Const ROW_BORSTART As Double = ROW_BORLEFT + ROW_BORINH + ROW_BORINV + ROW_BORRIGHT + ROW_BORTOP
    Public Const ROW_BORSTD As Decimal = ROW_BORLEFT + ROW_BORINV + ROW_BORRIGHT
    Public Const ROW_BOREND As Single = ROW_BORLEFT + ROW_BORINV + ROW_BORRIGHT + ROW_BORBOTTOM

    'Table - flags
    Public Const TBL_USECUSTOMBORDERS As Short = 128

    'Table - Borders selection
    Public Const BORDER_TOPLEFT As Short = 0
    Public Const BORDER_TOP As Short = 1
    Public Const BORDER_TOPRIGHT As Short = 2
    Public Const BORDER_LEFT As Short = 3
    Public Const BORDER_LEFTSMALL As Short = 3
    Public Const BORDER_LEFTBIG As Short = 4
    Public Const BORDER_RIGHT As Short = 5
    Public Const BORDER_RIGHTSMALL As Short = 5
    Public Const BORDER_RIGHTBIG As Short = 6
    Public Const BORDER_BOTTOMLEFT As Short = 7
    Public Const BORDER_BOTTOM As Short = 8
    Public Const BORDER_BOTTOMRIGHT As Short = 9
    Public Const BORDER_INSIDEH As Short = 10
    Public Const BORDER_INSIDEV As Short = 11
    Public Const BORDER_INSIDEVSMALL As Short = 11
    Public Const BORDER_INSIDEVBIG As Short = 12
    Public Const BORDER_INSIDECROSS As Short = 13
    Public Const BORDER_TOPINSIDE As Short = 14
    Public Const BORDER_BOTTOMINSIDE As Short = 15
    Public Const BORDER_LEFTINSIDE As Short = 16
    Public Const BORDER_RIGHTINSIDE As Short = 17

    'Table - Custom Table Sets
    Public Const TBL_DOTS As Short = 0
    Public Const TBL_PARAGRAPH As Short = 1
    Public Const TBL_SPIDER As Short = 2
    Public Const TBL_STANDART As Short = 3
    Public Const TBL_STANDARTHF As Short = 4
    Public Const TBL_STANDART_SHADOW As Short = 5
    Public Const TBL_STANDART_SMOOTHHF As Short = 6
    Public Const TBL_SMOOTH As Short = 7
    Public Const TBL_WAVY As Short = 8
    Public Const TBL_WAVY_SHADOW As Short = 9

    'PrnDrawText flags
    Public Const prnDrawTextLeft As Short = &H1S
    Public Const prnDrawTextCenter As Short = &H2S
    Public Const prnDrawTextRight As Short = &H4S
    Public Const prnDrawTextBottom As Short = &H10S
    Public Const prnDrawTextVCenter As Short = &H20S
    Public Const prnDrawTextTop As Short = &H40S
    Public Const prnDrawTextSingleLine As Short = &H100S
    Public Const prnDrawTextMultiLine As Short = &H200S
    Public Const prnDrawTextUInt16Break As Short = &H400S
    Public Const prnDrawTextClip As Short = &H1000S
    Public Const prnDrawTextNoClip As Short = &H2000S

    Public Const prnDrawTextHorzAlignMask As Short = &HFS
    Public Const prnDrawTextVertAlignMask As Short = &HF0S
    Public Const prnDrawTextLineFormatMask As Short = &HF00S
    Public Const prnDrawTextClippingMask As Short = &HF000S


    'PalmOS internal fonts
    Public Const PALM_stdFont As Short = 0
    Public Const PALM_boldFont As Short = 1
    Public Const PALM_largeFont As Short = 2
    Public Const PALM_symbolFont As Short = 3
    Public Const PALM_symbol11Font As Short = 4
    Public Const PALM_symbol7Font As Short = 5
    Public Const PALM_ledFont As Short = 6
    Public Const PALM_largeBoldFont As Short = 7
    Public Const PALM_fntAppFontCustomBase As Short = 128

    'PalmOS internal draw modes
    Public Const PALM_winPaint As Short = 0
    Public Const PALM_winErase As Short = 1
    Public Const PALM_winMask As Short = 2
    Public Const PALM_winInvert As Short = 3
    Public Const PALM_winOverlay As Short = 4
    Public Const PALM_winPaintInverse As Short = 5
    Public Const PALM_winSwap As Short = 6

    'PalmOS underline modes
    Public Const PALM_noUnderline As Short = 0
    Public Const PALM_grayUnderline As Short = 1
    Public Const PALM_solidUnderline As Short = 2
    Public Const PALM_colorUnderline As Short = 3


    '================================================================================='
    Private Const DP_INITPRINTER As Integer = 1 + 32768
    Private Const DP_DONEPRINTER As Integer = 2 + 32768

    Private Const DP_LINEFEED As Integer = 10 + 32768
    Private Const DP_SELFTEST As Integer = 11 + 32768
    Private Const DP_PRINTTEXT As Integer = 12 + 32768
    Private Const DP_PRINTTEXTWRAPPED As Integer = 13 + 32768
    Private Const DP_PRINTBARCODE As Integer = 14 + 32768
    Private Const DP_PRINTBUFFER As Integer = 15 + 32768
    Private Const DP_PRINTIMAGE As Integer = 16 + 32768
    Private Const DP_PRINTLOGO As Integer = 17 + 32768
    Private Const DP_PRINTSCREEN As Integer = 18 + 32768
    Private Const DP_PRINTBARCODEN As Integer = 19 + 32768

    Private Const DP_SETALIGN As Integer = 20 + 32768
    Private Const DP_SETAUTOLINEFEED As Integer = 21 + 32768
    Private Const DP_SETBOLD As Integer = 22 + 32768
    Private Const DP_SETBARCODESCALE As Integer = 23 + 32768
    Private Const DP_SETBARCODEHEIGHT As Integer = 24 + 32768
    Private Const DP_SETBARCODETEXT As Integer = 25 + 32768
    Private Const DP_SETINTENSITY As Integer = 26 + 32768
    Private Const DP_SETFONT As Integer = 27 + 32768
    Private Const DP_SETUNDERLINE As Integer = 28 + 32768
    Private Const DP_SET90DEGREE As Integer = 29 + 32768
    Private Const DP_SETREVERSE As Integer = 30 + 32768
    Private Const DP_SETBARCODEALIGN As Integer = 31 + 32768

    Private Const DP_GETPRINTVER As Integer = 39 + 32768
    Private Const DP_GETLASTERROR As Integer = 40 + 32768
    Private Const DP_GETBATTERY As Integer = 41 + 32768
    Private Const DP_GETTEMPERATURE As Integer = 42 + 32768

    Private Const DP_UPLOADLOGO As Integer = 43 + 32768

    Private Const DP_TEXTSTART As Integer = 44 + 32768
    Private Const DP_TEXTEND As Integer = 45 + 32768
    Private Const DP_TEXTOUT As Integer = 46 + 32768
    Private Const DP_TEXTOUTN As Integer = 47 + 32768
    Private Const DP_TEXTCHARSPACE As Integer = 48 + 32768
    Private Const DP_TEXTFONT As Integer = 49 + 32768
    Private Const DP_TEXTUNDERLINE As Integer = 50 + 32768
    Private Const DP_TEXTBOLD As Integer = 51 + 32768
    Private Const DP_TEXT90DEGREE As Integer = 52 + 32768
    Private Const DP_TEXTINTENSITY As Integer = 53 + 32768
    Private Const DP_TEXTALIGN As Integer = 54 + 32768
    Private Const DP_TEXT180DEGREE As Integer = 55 + 32768
    Private Const DP_GETRELEASE As Integer = 56 + 32768
    Private Const DP_READCARDTRACKS As Integer = 57 + 32768
    Private Const DP_READPAYMENTCARD As Integer = 58 + 32768
    Private Const DP_SETIMAGESETTINGS As Integer = 59 + 32768
    Private Const DP_SCREENCAPTURE As Integer = 60 + 32768
    Private Const DP_READBARCODE As Integer = 61 + 32768
    Private Const DP_PRINTBITMAP As Integer = 62 + 32768

    Private Const DP_PRINTBITMAPNEW As Integer = 63 + 32768

    Private Const DP_REGISTER As Integer = 64 + 32768
    Private Const DP_EXTOPENCONNECTION As Integer = 65 + 32768
    Private Const DP_EXTSENDDATA As Integer = 66 + 32768
    Private Const DP_EXTRECEIVEDATA As Integer = 67 + 32768
    Private Const DP_EXTRECEIVEDATASTOP As Integer = 68 + 32768
    Private Const DP_EXTCLOSECONNECTION As Integer = 69 + 32768
    Private Const DP_EXTGETDTR As Integer = 70 + 32768
    Private Const DP_EXTSETDTR As Integer = 71 + 32768
    Private Const DP_EXTGETRTS As Integer = 72 + 32768
    Private Const DP_EXTGETCTS As Integer = 73 + 32768
    Private Const DP_EXTGETDSR As Integer = 74 + 32768
    Private Const DP_EXTGETBREAK As Integer = 75 + 32768
    Private Const DP_EXTSETBREAK As Integer = 76 + 32768

    Private Const DP_PRNSTARTPAGE As Integer = 77 + 32768
    Private Const DP_PRNCLOSE As Integer = 78 + 32768
    Private Const DP_PRNDRAWBITMAP As Integer = 79 + 32768
    Private Const DP_PRNDRAWCHARS As Integer = 80 + 32768
    Private Const DP_PRNDRAWTRUNCCHARS As Integer = 81 + 32768
    Private Const DP_PRNDRAWGRAYLINE As Integer = 82 + 32768
    Private Const DP_PRNDRAWGRAYRECTANGLE As Integer = 83 + 32768
    Private Const DP_PRNFILLRECTANGLE As Integer = 84 + 32768
    Private Const DP_PRNDRAWGRAYRECTANGLEFRAME As Integer = 85 + 32768
    Private Const DP_PRNDRAWLINE As Integer = 86 + 32768
    Private Const DP_PRNDRAWRECTANGLE As Integer = 87 + 32768
    Private Const DP_PRNDRAWRECTANGLEFRAME As Integer = 88 + 32768
    Private Const DP_PRNDRAWTEXT As Integer = 89 + 32768
    Private Const DP_PRNGETFONT As Integer = 90 + 32768
    Private Const DP_PRNGETPAGEEXTENT As Integer = 91 + 32768
    Private Const DP_PRNGETPATTERN As Integer = 92 + 32768
    Private Const DP_PRNGETUNDERLINEMODE As Integer = 93 + 32768
    Private Const DP_PRNENDPAGE As Integer = 94 + 32768
    Private Const DP_PRNSETFONT As Integer = 95 + 32768
    Private Const DP_PRNSETPATTERN As Integer = 96 + 32768
    Private Const DP_PRNSETUNDERLINEMODE As Integer = 97 + 32768
    Private Const DP_PRNGETAVARAGECHARWIDTH As Integer = 98 + 32768
    Private Const DP_PRNGETCHARHEIGHT As Integer = 99 + 32768
    Private Const DP_PRNGETCHARWIDTH As Integer = 100 + 32768
    Private Const DP_PRNGETCHARSINWIDTH As Integer = 101 + 32768
    Private Const DP_PRNGETCHARSWIDTH As Integer = 102 + 32768
    Private Const DP_PRNSETTEXTMODE As Integer = 103 + 32768
    Private Const DP_PRNGETTEXTMODE As Integer = 104 + 32768

    Private Const DP_SCREENINFO As Integer = 105 + 32768

    Private Const DP_LINEFEEDX As Integer = 106 + 32768
    Private Const DP_PPBARCODEREAD As Integer = 107 + 32768
    Private Const DP_GETPRINTERCAPABILITIES As Integer = 108 + 32768
    Private Const DP_GETPRINTERTYPE As Integer = 109 + 32768
    Private Const DP_SETPRINTERTYPE As Integer = 110 + 32768
    Private Const DP_GETCONNECTIONTYPE As Integer = 111 + 32768
    Private Const DP_SETCONNECTIONTYPE As Integer = 112 + 32768
    Private Const DP_GETCONNECTIONSPEED As Integer = 113 + 32768
    Private Const DP_SETCONNECTIONSPEED As Integer = 114 + 32768
    Private Const DP_CHANGEPRINTERSPEED As Integer = 115 + 32768
    Private Const DP_DETECTPRINTER As Integer = 116 + 32768
    Private Const DP_GETSTATUS As Integer = 117 + 32768
    Private Const DP_SETLEFTMARGIN As Integer = 118 + 32768
    Private Const DP_PROCESSPAYMENTCARDDATA As Integer = 119 + 32768
    Private Const DP_PROCESSPAYMENTCARDTRACKS As Integer = 120 + 32768
    Private Const DP_CONTROLPANEL As Integer = 121 + 32768
    Private Const DP_RESETDEFAULTS As Integer = 122 + 32768
    Private Const DP_SETLINESPACE As Integer = 123 + 32768
    Private Const DP_SETFONTDOUBLEHEIGHT As Integer = 124 + 32768
    Private Const DP_SETFONTDOUBLEWIDTH As Integer = 125 + 32768
    Private Const DP_PRINTTEXTEX As Integer = 126 + 32768
    Private Const DP_SETITALIC As Integer = 127 + 32768
    Private Const DP_SETROWBORDERS As Integer = 128 + 32768
    Private Const DP_SETCUSTOMROWBORDERS As Integer = 129 + 32768
    Private Const DP_LOADCUSTOMBORDERSET As Integer = 130 + 32768
    Private Const DP_STARTTABLE As Integer = 131 + 32768
    Private Const DP_STARTROW As Integer = 132 + 32768
    Private Const DP_SETCOL As Integer = 133 + 32768
    Private Const DP_FILLCOL As Integer = 134 + 32768
    Private Const DP_ENDROW As Integer = 135 + 32768
    Private Const DP_ENDTABLE As Integer = 136 + 32768
    Private Const DP_FILLCOLINT As Integer = 137 + 32768
    Private Const DP_FILLCOLDOUBLE As Integer = 138 + 32768
    Private Const DP_GETROMSERIALNUMBER As Integer = 139 + 32768
    Private Const DP_BARCODETYPE2TEXT As Integer = 140 + 32768
    Private Const DP_GETLIBRARYINFO As Integer = 141 + 32768
    Private Const DP_PPBARCODEGETPARAM As Integer = 142 + 32768
    Private Const DP_PPBARCODESETPARAM As Integer = 143 + 32768
    Private Const DP_PPBARCODECONTROLPANEL As Integer = 144 + 32768

    <StructLayout(LayoutKind.Sequential, Pack:=4)> _
    Private Structure TSend
        Dim str1 As String
        Dim str2 As String
        Dim str3 As String
        Dim int1 As Integer
        Dim int2 As Integer
        Dim int3 As Integer
        Dim int4 As Integer
        Dim int5 As Integer
        Dim buffer As Integer
        Dim ret As Integer
        Dim dbl1 As Double
    End Structure

    Dim send As TSend





    Public Function InitPrinter() As Boolean
        Dim R As Boolean
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_INITPRINTER, send)
        If send.ret <> 0 Then
            InitPrinter = True
        Else
            InitPrinter = False
        End If
    End Function

    Public Function DonePrinter() As Boolean
        Dim R As Boolean
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_DONEPRINTER, send)
        If send.ret <> 0 Then
            DonePrinter = True
        Else
            DonePrinter = False
        End If
    End Function

    Public Function LineFeed() As Boolean
        Dim R As Boolean
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_LINEFEED, send)
        If send.ret <> 0 Then
            LineFeed = True
        Else
            LineFeed = False
        End If
    End Function

    Public Function PrintText(ByVal text As String) As Boolean
        Dim R As Boolean

        send.str1 = text
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_PRINTTEXT, send)
        If send.ret <> 0 Then
            PrintText = True
        Else
            PrintText = False
        End If
    End Function

    Public Function SelfTest(ByRef longtest As Boolean) As Boolean
        Dim R As Boolean
        If longtest = True Then
            send.int1 = 1
        Else
            send.int1 = 0
        End If
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_SELFTEST, send)
        If send.ret <> 0 Then
            SelfTest = True
        Else
            SelfTest = False
        End If
    End Function

    Public Function PrintTextWrapped(ByVal text As String) As Boolean
        Dim R As Boolean
        send.str1 = text
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_PRINTTEXTWRAPPED, send)
        If send.ret <> 0 Then
            PrintTextWrapped = True
        Else
            PrintTextWrapped = False
        End If
    End Function

    Public Function PrintBarcode(ByRef bartype As Short, ByVal barcode As String) As Boolean
        Dim R As Boolean
        send.str1 = barcode
        send.int1 = bartype
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_PRINTBARCODE, send)
        If send.ret <> 0 Then
            PrintBarcode = True
        Else
            PrintBarcode = False
        End If
    End Function

    Public Function PrintBarcodeN(ByRef bartype As Short, ByVal barcode As String, ByRef barlen As Short) As Boolean
        Dim R As Boolean
        send.int1 = bartype
        send.str1 = barcode
        send.int2 = barlen
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_PRINTBARCODEN, send)
        If send.ret <> 0 Then
            PrintBarcodeN = True
        Else
            PrintBarcodeN = False
        End If
    End Function

    Public Function PrintBuffer(ByVal buf As String, ByRef size As Short) As Boolean
        Dim R As Boolean
        send.str1 = buf
        send.int1 = size
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_PRINTBUFFER, send)
        If send.ret <> 0 Then
            PrintBuffer = True
        Else
            PrintBuffer = False
        End If
    End Function

    Public Function PrintImage(ByRef x As Short, ByRef y As Short, ByRef bufpointer As Integer) As Boolean
        Dim R As Boolean
        send.buffer = bufpointer
        send.int1 = x
        send.int2 = y
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_PRINTIMAGE, send)
        If send.ret <> 0 Then
            PrintImage = True
        Else
            PrintImage = False
        End If
    End Function

    Public Function UploadLogo(ByVal file As String) As Boolean
        Dim R As Boolean
        send.str1 = file
        send.int1 = 0
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_UPLOADLOGO, send)
        If send.ret <> 0 Then
            UploadLogo = True
        Else
            UploadLogo = False
        End If
    End Function

    Public Function PrintLogo(ByRef mode As Short) As Boolean
        Dim R As Boolean
        send.int1 = mode
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_PRINTLOGO, send)
        If send.ret <> 0 Then
            PrintLogo = True
        Else
            PrintLogo = False
        End If
    End Function

    Public Function SetImageSettings(ByRef brightenabled As Boolean, ByRef brightness As Short, ByRef contrastenabled As Boolean, ByRef contrast As Short) As Boolean
        Dim R As Boolean
        If brightenabled = True Then
            send.int1 = 1
        Else
            send.int1 = 0
        End If
        If contrastenabled = True Then
            send.int3 = 1
        Else
            send.int3 = 0
        End If
        send.int2 = brightness
        send.int4 = contrast
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_SETIMAGESETTINGS, send)
        If send.ret <> 0 Then
            SetImageSettings = True
        Else
            SetImageSettings = False
        End If
    End Function

    Public Function PrintScreen(ByRef x As Short, ByRef y As Short, ByRef w As Short, ByRef h As Short, ByRef percent As Short) As Boolean
        Dim R As Boolean
        send.int1 = x
        send.int2 = y
        send.int3 = w
        send.int4 = h
        send.int5 = percent
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_PRINTSCREEN, send)
        If send.ret <> 0 Then
            PrintScreen = True
        Else
            PrintScreen = False
        End If
    End Function

    Public Function ScreenCapture(ByRef x As Short, ByRef y As Short, ByRef w As Short, ByRef h As Short, ByRef percent As Short, ByRef bufpointer As Integer) As Boolean
        Dim R As Boolean
        send.int1 = x
        send.int2 = y
        send.int3 = w
        send.int4 = h
        send.int5 = percent
        send.buffer = bufpointer
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_SCREENCAPTURE, send)
        If send.ret <> 0 Then
            ScreenCapture = True
        Else
            ScreenCapture = False
        End If
    End Function

    Public Function SetAlign(ByRef align As Short) As Boolean
        Dim R As Boolean
        send.int1 = align
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_SETALIGN, send)
        If send.ret <> 0 Then
            SetAlign = True
        Else
            SetAlign = False
        End If
    End Function

    Public Function SetAutoLineFeed(ByRef autolf As Boolean) As Boolean
        Dim R As Boolean
        If autolf = True Then
            send.int1 = 1
        Else
            send.int1 = 0
        End If
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_SETAUTOLINEFEED, send)
        If send.ret <> 0 Then
            SetAutoLineFeed = True
        Else
            SetAutoLineFeed = False
        End If
    End Function

    Public Function SetBold(ByRef bold As Boolean) As Boolean
        Dim R As Boolean
        If bold = True Then
            send.int1 = 1
        Else
            send.int1 = 0
        End If
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_SETBOLD, send)
        If send.ret <> 0 Then
            SetBold = True
        Else
            SetBold = False
        End If
    End Function

    Public Function SetBarcodeScale(ByRef barscale As Short) As Boolean
        Dim R As Boolean
        send.int1 = barscale
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_SETBARCODESCALE, send)
        If send.ret <> 0 Then
            SetBarcodeScale = True
        Else
            SetBarcodeScale = False
        End If
    End Function

    Public Function SetBarcodeHeight(ByRef barheight As Short) As Boolean
        Dim R As Boolean
        send.int1 = barheight
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_SETBARCODEHEIGHT, send)
        If send.ret <> 0 Then
            SetBarcodeHeight = True
        Else
            SetBarcodeHeight = False
        End If
    End Function

    Public Function SetBarcodeText(ByRef bartext As Short) As Boolean
        Dim R As Boolean
        send.int1 = bartext
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_SETBARCODETEXT, send)
        If send.ret <> 0 Then
            SetBarcodeText = True
        Else
            SetBarcodeText = False
        End If
    End Function

    Public Function SetIntensity(ByRef intesity As Short) As Boolean
        Dim R As Boolean
        send.int1 = intesity
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_SETINTENSITY, send)
        If send.ret <> 0 Then
            SetIntensity = True
        Else
            SetIntensity = False
        End If
    End Function

    Public Function SetFont(ByRef font As Short) As Boolean
        Dim R As Boolean
        send.int1 = font
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_SETFONT, send)
        If send.ret <> 0 Then
            SetFont = True
        Else
            SetFont = False
        End If
    End Function

    Public Function SetUnderline(ByRef underline As Boolean) As Boolean
        Dim R As Boolean
        If underline = True Then
            send.int1 = 1
        Else
            send.int1 = 0
        End If
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_SETUNDERLINE, send)
        If send.ret <> 0 Then
            SetUnderline = True
        Else
            SetUnderline = False
        End If
    End Function

    Public Function Set90degree(ByRef degree As Boolean) As Boolean
        Dim R As Boolean
        If degree = True Then
            send.int1 = 1
        Else
            send.int1 = 0
        End If
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_SET90DEGREE, send)
        If send.ret <> 0 Then
            Set90degree = True
        Else
            Set90degree = False
        End If
    End Function

    Public Function SetReverse(ByRef reverse As Boolean) As Boolean
        Dim R As Boolean
        If reverse = True Then
            send.int1 = 1
        Else
            send.int1 = 0
        End If
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_SETREVERSE, send)
        If send.ret <> 0 Then
            SetReverse = True
        Else
            SetReverse = False
        End If
    End Function

    Public Function SetBarcodeAlign(ByRef align As Short) As Boolean
        Dim R As Boolean
        send.int1 = align
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_SETBARCODEALIGN, send)
        If send.ret <> 0 Then
            SetBarcodeAlign = True
        Else
            SetBarcodeAlign = False
        End If
    End Function

    Public Function GetBattery() As Short
        Dim R As Boolean

        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_GETBATTERY, send)
        GetBattery = send.int1
    End Function

    Public Function GetTemperature() As Short
        Dim R As Boolean

        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_GETTEMPERATURE, send)
        GetTemperature = send.int1
    End Function

    Public Function GetPrinterVersion() As Short
        Dim R As Boolean

        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_GETPRINTVER, send)
        GetPrinterVersion = send.int1
    End Function

    Public Function GetRelease() As Short
        Dim R As Boolean

        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_GETRELEASE, send)
        GetRelease = send.int1
    End Function

    'UPGRADE_NOTE: month was upgraded to month_Renamed. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1061"'
    'UPGRADE_NOTE: year was upgraded to year_Renamed. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1061"'
    Public Function ReadPaymentCard(ByRef name As String, ByRef number As String, ByRef year_Renamed As Short, ByRef month_Renamed As Short, ByRef timeoutsec As Short) As Boolean
        Dim R As Boolean

        send.int3 = timeoutsec
        send.str1 = "                                                                                                                                                      "
        send.str2 = "                                                                                                                                                      "
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_READPAYMENTCARD, send)
        If send.ret <> 0 Then
            name = send.str1
            number = send.str2
            month_Renamed = send.int1
            year_Renamed = send.int2
            If year_Renamed > 80 And year_Renamed < 99 Then
                year_Renamed = year_Renamed + 1900
            Else
                year_Renamed = year_Renamed + 2000
            End If
            ReadPaymentCard = True
        Else
            ReadPaymentCard = False
        End If
    End Function

    Public Function ReadCardTracks(ByRef track1 As String, ByRef track2 As String, ByRef track3 As String, ByRef timeoutsec As Short) As Boolean
        Dim R As Boolean

        send.int1 = timeoutsec
        send.str1 = "                                                                                                                                                      "
        send.str2 = "                                                                                                                                                      "
        send.str3 = "                                                                                                                                                      "
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_READCARDTRACKS, send)
        If send.ret <> 0 Then
            track1 = send.str1
            track2 = send.str2
            track3 = send.str3
            ReadCardTracks = True
        Else
            ReadCardTracks = False
        End If
    End Function

    Public Function TextStart() As Boolean
        Dim R As Boolean
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_TEXTSTART, send)
        If send.ret <> 0 Then
            TextStart = True
        Else
            TextStart = False
        End If
    End Function

    Public Function TextEnd() As Boolean
        Dim R As Boolean
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_TEXTEND, send)
        If send.ret <> 0 Then
            TextEnd = True
        Else
            TextEnd = False
        End If
    End Function

    Public Function TextOut(ByVal text As String) As Boolean
        Dim R As Boolean
        send.str1 = text
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_TEXTOUT, send)
        If send.ret <> 0 Then
            TextOut = True
        Else
            TextOut = False
        End If
    End Function

    Public Function TextOutN(ByVal text As String, ByRef length As Short) As Boolean
        Dim R As Boolean
        send.str1 = text
        send.int1 = length
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_TEXTOUTN, send)
        If send.ret <> 0 Then
            TextOutN = True
        Else
            TextOutN = False
        End If
    End Function

    'UPGRADE_NOTE: space was upgraded to space_Renamed. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1061"'
    Public Function TextCharSpace(ByRef space_Renamed As Short) As Boolean
        Dim R As Boolean
        send.int1 = space_Renamed
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_TEXTCHARSPACE, send)
        If send.ret <> 0 Then
            TextCharSpace = True
        Else
            TextCharSpace = False
        End If
    End Function

    Public Function TextFont(ByRef big As Boolean, ByRef bold As Boolean, ByRef doubleheight As Boolean, ByRef doublewidth As Boolean, ByRef underline As Boolean) As Boolean
        Dim R As Boolean
        If big = True Then
            send.int1 = 1
        Else
            send.int1 = 0
        End If
        If bold = True Then
            send.int2 = 1
        Else
            send.int2 = 0
        End If
        If doubleheight = True Then
            send.int3 = 1
        Else
            send.int3 = 0
        End If
        If doublewidth = True Then
            send.int4 = 1
        Else
            send.int4 = 0
        End If
        If underline = True Then
            send.int5 = 1
        Else
            send.int5 = 0
        End If

        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_TEXTFONT, send)
        If send.ret <> 0 Then
            TextFont = True
        Else
            TextFont = False
        End If
    End Function

    Public Function TextUnderline(ByRef underline As Short) As Boolean
        Dim R As Boolean
        send.int1 = underline
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_TEXTUNDERLINE, send)
        If send.ret <> 0 Then
            TextUnderline = True
        Else
            TextUnderline = False
        End If
    End Function

    Public Function TextBold(ByRef bold As Boolean) As Boolean
        Dim R As Boolean
        If bold = True Then
            send.int1 = 1
        Else
            send.int1 = 0
        End If
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_TEXTBOLD, send)
        If send.ret <> 0 Then
            TextBold = True
        Else
            TextBold = False
        End If
    End Function

    Public Function Text90degree(ByRef degree90 As Boolean) As Boolean
        Dim R As Boolean
        If degree90 = True Then
            send.int1 = 1
        Else
            send.int1 = 0
        End If
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_TEXT90DEGREE, send)
        If send.ret <> 0 Then
            Text90degree = True
        Else
            Text90degree = False
        End If
    End Function

    Public Function TextIntensity(ByRef intensity As Short) As Boolean
        Dim R As Boolean
        send.int1 = intensity
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_TEXTINTENSITY, send)
        If send.ret <> 0 Then
            TextIntensity = True
        Else
            TextIntensity = False
        End If
    End Function

    Public Function TextAlign(ByRef align As Short) As Boolean
        Dim R As Boolean
        send.int1 = align
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_TEXTALIGN, send)
        If send.ret <> 0 Then
            TextAlign = True
        Else
            TextAlign = False
        End If
    End Function

    Public Function Text180degree(ByRef degree180 As Boolean) As Boolean
        Dim R As Boolean
        If degree180 = True Then
            send.int1 = 1
        Else
            send.int1 = 0
        End If
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_TEXT180DEGREE, send)
        If send.ret <> 0 Then
            Text180degree = True
        Else
            Text180degree = False
        End If
    End Function

    Public Function ReadBarcode(ByRef bartext As String, ByRef timeoutsec As Short) As Boolean
        Dim R As Boolean

        send.int1 = timeoutsec
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_PRINTTEXTWRAPPED, send)
        If send.ret <> 0 Then
            bartext = send.str1
            ReadBarcode = True
        Else
            ReadBarcode = False
        End If
    End Function

    Public Function PrintBitmap(ByVal file As String) As Boolean
        Dim R As Boolean
        send.str1 = file
        send.int1 = 0
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_PRINTBITMAP, send)
        If send.ret <> 0 Then
            PrintBitmap = True
        Else
            PrintBitmap = False
        End If
    End Function

    Public Function PrintBitmapNew(ByVal file As String, ByRef x As Short, ByRef y As Short, ByRef w As Short, ByRef h As Short, ByRef percents As Short) As Boolean
        Dim R As Boolean
        send.str1 = file
        send.int1 = x
        send.int2 = y
        send.int3 = w
        send.int4 = h
        send.int5 = percents
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_PRINTBITMAPNEW, send)
        If send.ret <> 0 Then
            PrintBitmapNew = True
        Else
            PrintBitmapNew = False
        End If
    End Function

    Public Function REGISTER(ByVal number As String) As Boolean
        Dim R As Boolean
        send.str1 = number
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_REGISTER, send)
        If send.ret <> 0 Then
            REGISTER = True
        Else
            REGISTER = False
        End If
    End Function

    Public Function ExtOpenConnection(ByRef baudrate As Short, ByRef databits As Short, ByRef stopbits As Short, ByRef parity As Short) As Boolean
        Dim R As Boolean
        send.int1 = baudrate
        send.int2 = databits
        send.int3 = stopbits
        send.int4 = parity
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_EXTOPENCONNECTION, send)
        If send.ret <> 0 Then
            ExtOpenConnection = True
        Else
            ExtOpenConnection = False
        End If
    End Function

    Public Function ExtSendData(ByVal buf As String, ByRef length As Short, ByRef timeout As Short) As Boolean
        Dim R As Boolean
        send.str1 = buf
        send.int1 = length
        send.int2 = timeout
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_EXTSENDDATA, send)
        If send.ret <> 0 Then
            ExtSendData = True
        Else
            ExtSendData = False
        End If
    End Function

    Public Function ExtReceiveData(ByRef buf As String, ByRef length As Short, ByRef timeout As Short) As Short
        Dim R As Boolean
        send.str1 = buf
        send.int1 = length
        send.int2 = timeout
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_EXTRECEIVEDATA, send)
        If send.ret <> 0 Then
            buf = send.str1
            ExtReceiveData = True
        Else
            ExtReceiveData = False
        End If
    End Function

    Public Function ExtReceiveDataStop(ByRef buf As String, ByRef length As Short, ByRef timeout As Short, ByRef stopbyte As Byte) As Short
        Dim R As Boolean
        send.str1 = buf
        send.int1 = length
        send.int2 = timeout
        send.int3 = stopbyte
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_EXTRECEIVEDATASTOP, send)
        If send.ret <> 0 Then
            buf = send.str1
            ExtReceiveDataStop = True
        Else
            ExtReceiveDataStop = False
        End If
    End Function

    Public Function ExtCloseConnection() As Boolean
        Dim R As Boolean
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_EXTCLOSECONNECTION, send)
        If send.ret <> 0 Then
            ExtCloseConnection = True
        Else
            ExtCloseConnection = False
        End If
    End Function

    Public Function ExtGetDTR() As Boolean
        Dim R As Boolean
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_EXTGETDTR, send)
        If send.ret <> 0 Then
            ExtGetDTR = True
        Else
            ExtGetDTR = False
        End If
    End Function

    Public Function ExtSetDTR(ByRef dtr As Boolean) As Boolean
        Dim R As Boolean
        If dtr = True Then
            send.int1 = 1
        Else
            send.int1 = 0
        End If
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_EXTSETDTR, send)
        If send.ret <> 0 Then
            ExtSetDTR = True
        Else
            ExtSetDTR = False
        End If
    End Function

    Public Function ExtGetRTS() As Boolean
        Dim R As Boolean
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_EXTGETRTS, send)
        If send.ret <> 0 Then
            ExtGetRTS = True
        Else
            ExtGetRTS = False
        End If
    End Function

    Public Function ExtGetCTS() As Boolean
        Dim R As Boolean
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_EXTGETCTS, send)
        If send.ret <> 0 Then
            ExtGetCTS = True
        Else
            ExtGetCTS = False
        End If
    End Function

    Public Function ExtGetDSR() As Boolean
        Dim R As Boolean
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_EXTGETDSR, send)
        If send.ret <> 0 Then
            ExtGetDSR = True
        Else
            ExtGetDSR = False
        End If
    End Function

    Public Function ExtGetBreak() As Boolean
        Dim R As Boolean
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_EXTGETBREAK, send)
        If send.ret <> 0 Then
            ExtGetBreak = True
        Else
            ExtGetBreak = False
        End If
    End Function

    Public Function ExtSetBreak(ByRef break As Boolean) As Boolean
        Dim R As Boolean
        If break = True Then
            send.int1 = 1
        Else
            send.int1 = 0
        End If
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_EXTSETBREAK, send)
        If send.ret <> 0 Then
            ExtSetBreak = True
        Else
            ExtSetBreak = False
        End If
    End Function

    Public Function PrnStartPage(ByRef hsize As Short, ByRef vsize As Short) As Boolean
        Dim R As Boolean
        send.int1 = hsize
        send.int2 = vsize
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_PRNSTARTPAGE, send)
        If send.ret <> 0 Then
            PrnStartPage = True
        Else
            PrnStartPage = False
        End If
    End Function

    Public Function PrnClose() As Boolean
        Dim R As Boolean
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_PRNCLOSE, send)
        If send.ret <> 0 Then
            PrnClose = True
        Else
            PrnClose = False
        End If
    End Function

    Public Function PrnDrawBitmap(ByRef file As String, ByRef x As Short, ByRef y As Short) As Boolean
        Dim R As Boolean
        send.str1 = file
        send.int1 = x
        send.int2 = y
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_PRNDRAWBITMAP, send)
        If send.ret <> 0 Then
            PrnDrawBitmap = True
        Else
            PrnDrawBitmap = False
        End If
    End Function

    Public Function PrnDrawChars(ByRef text As String, ByRef x As Short, ByRef y As Short) As Boolean
        Dim R As Boolean
        send.str1 = text
        send.int1 = x
        send.int2 = y
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_PRNDRAWCHARS, send)
        If send.ret <> 0 Then
            PrnDrawChars = True
        Else
            PrnDrawChars = False
        End If
    End Function

    Public Function PrnDrawTruncChars(ByRef text As String, ByRef x As Short, ByRef y As Short, ByRef maxwidth As Short) As Boolean
        Dim R As Boolean
        send.str1 = text
        send.int1 = x
        send.int2 = y
        send.int3 = maxwidth
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_PRNDRAWTRUNCCHARS, send)
        If send.ret <> 0 Then
            PrnDrawTruncChars = True
        Else
            PrnDrawTruncChars = False
        End If
    End Function

    Public Function PrnDrawGrayLine(ByRef x1 As Short, ByRef y1 As Short, ByRef x2 As Short, ByRef y2 As Short) As Boolean
        Dim R As Boolean
        send.int1 = x1
        send.int2 = y1
        send.int3 = x2
        send.int4 = y2
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_PRNDRAWGRAYLINE, send)
        If send.ret <> 0 Then
            PrnDrawGrayLine = True
        Else
            PrnDrawGrayLine = False
        End If
    End Function

    'UPGRADE_NOTE: left was upgraded to left_Renamed. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1061"'
    Public Function PrnDrawGrayRectangle(ByRef left_Renamed As Short, ByRef top As Short, ByRef width As Short, ByRef height As Short, ByRef cornerdiam As Short) As Boolean
        Dim R As Boolean
        send.int1 = left_Renamed
        send.int2 = top
        send.int3 = width
        send.int4 = height
        send.int5 = cornerdiam
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_PRNDRAWGRAYRECTANGLE, send)
        If send.ret <> 0 Then
            PrnDrawGrayRectangle = True
        Else
            PrnDrawGrayRectangle = False
        End If
    End Function

    'UPGRADE_NOTE: left was upgraded to left_Renamed. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1061"'
    Public Function PrnDrawGrayRectangleFrame(ByRef left_Renamed As Short, ByRef top As Short, ByRef width As Short, ByRef height As Short, ByRef cornerdiam As Short) As Boolean
        Dim R As Boolean
        send.int1 = left_Renamed
        send.int2 = top
        send.int3 = width
        send.int4 = height
        send.int5 = cornerdiam
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_PRNDRAWGRAYRECTANGLEFRAME, send)
        If send.ret <> 0 Then
            PrnDrawGrayRectangleFrame = True
        Else
            PrnDrawGrayRectangleFrame = False
        End If
    End Function

    Public Function PrnDrawLine(ByRef x1 As Short, ByRef y1 As Short, ByRef x2 As Short, ByRef y2 As Short) As Boolean
        Dim R As Boolean
        send.int1 = x1
        send.int2 = y1
        send.int3 = x2
        send.int4 = y2
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_PRNDRAWLINE, send)
        If send.ret <> 0 Then
            PrnDrawLine = True
        Else
            PrnDrawLine = False
        End If
    End Function

    'UPGRADE_NOTE: left was upgraded to left_Renamed. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1061"'
    Public Function PrnDrawRectangle(ByRef left_Renamed As Short, ByRef top As Short, ByRef width As Short, ByRef height As Short, ByRef cornerdiam As Short) As Boolean
        Dim R As Boolean
        send.int1 = left_Renamed
        send.int2 = top
        send.int3 = width
        send.int4 = height
        send.int5 = cornerdiam
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_PRNDRAWRECTANGLE, send)
        If send.ret <> 0 Then
            PrnDrawRectangle = True
        Else
            PrnDrawRectangle = False
        End If
    End Function

    'UPGRADE_NOTE: left was upgraded to left_Renamed. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1061"'
    Public Function PrnFillRectangle(ByRef left_Renamed As Short, ByRef top As Short, ByRef width As Short, ByRef height As Short, ByRef cornerdiam As Short) As Boolean
        Dim R As Boolean
        send.int1 = left_Renamed
        send.int2 = top
        send.int3 = width
        send.int4 = height
        send.int5 = cornerdiam
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_PRNFILLRECTANGLE, send)
        If send.ret <> 0 Then
            PrnFillRectangle = True
        Else
            PrnFillRectangle = False
        End If
    End Function

    'UPGRADE_NOTE: left was upgraded to left_Renamed. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1061"'
    Public Function PrnDrawRectangleFrame(ByRef left_Renamed As Short, ByRef top As Short, ByRef width As Short, ByRef height As Short, ByRef cornerdiam As Short) As Boolean
        Dim R As Boolean
        send.int1 = left_Renamed
        send.int2 = top
        send.int3 = width
        send.int4 = height
        send.int5 = cornerdiam
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_PRNDRAWRECTANGLEFRAME, send)
        If send.ret <> 0 Then
            PrnDrawRectangleFrame = True
        Else
            PrnDrawRectangleFrame = False
        End If
    End Function

    'UPGRADE_NOTE: left was upgraded to left_Renamed. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1061"'
    Public Function PrnDrawText(ByRef text As String, ByRef left_Renamed As Short, ByRef top As Short, ByRef width As Short, ByRef height As Short, ByRef flags As Short) As Boolean
        Dim R As Boolean
        send.str1 = text
        send.int1 = left_Renamed
        send.int2 = top
        send.int3 = width
        send.int4 = height
        send.int5 = flags
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_PRNDRAWTEXT, send)
        If send.ret <> 0 Then
            PrnDrawText = True
        Else
            PrnDrawText = False
        End If
    End Function

    Public Function PrnGetFont() As Short
        Dim R As Boolean
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_PRNGETFONT, send)
        If send.ret <> 0 Then
            PrnGetFont = send.int1
        Else
            PrnGetFont = 0
        End If
    End Function

    Public Function PrnGetPageExtent(ByRef extentx As Short, ByRef extenty As Short) As Boolean
        Dim R As Boolean
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_PRNGETPAGEEXTENT, send)
        If send.ret <> 0 Then
            extentx = send.int1
            extenty = send.int2
            PrnGetPageExtent = True
        Else
            PrnGetPageExtent = False
        End If
    End Function

    Public Function PrnGetUnderlineMode() As Short
        Dim R As Boolean
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_PRNGETUNDERLINEMODE, send)
        If send.ret <> 0 Then
            PrnGetUnderlineMode = send.int1
        Else
            PrnGetUnderlineMode = 0
        End If
    End Function

    Public Function PrnSetUnderlineMode(ByRef mode As Short) As Boolean
        Dim R As Boolean

        send.int1 = mode
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_PRNSETUNDERLINEMODE, send)
        If send.ret <> 0 Then
            PrnSetUnderlineMode = True
        Else
            PrnSetUnderlineMode = False
        End If
    End Function

    Public Function PrnGetAverageCharWidth() As Short
        Dim R As Boolean
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_PRNGETAVARAGECHARWIDTH, send)
        If send.ret <> 0 Then
            PrnGetAverageCharWidth = send.int1
        Else
            PrnGetAverageCharWidth = 0
        End If
    End Function

    Public Function PrnGetCharHeight() As Short
        Dim R As Boolean
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_PRNGETCHARHEIGHT, send)
        If send.ret <> 0 Then
            PrnGetCharHeight = send.int1
        Else
            PrnGetCharHeight = 0
        End If
    End Function

    Public Function PrnGetCharWidth(ByRef ch As Byte) As Short
        Dim R As Boolean
        send.int1 = ch
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_PRNGETCHARWIDTH, send)
        If send.ret <> 0 Then
            PrnGetCharWidth = send.int1
        Else
            PrnGetCharWidth = 0
        End If
    End Function

    Public Function PrnGetCharsInWidth(ByRef text As String, ByRef stringWidthP As Short, ByRef stringLengthP As Short, ByRef fitWithinWidth As Boolean) As Boolean
        Dim R As Boolean
        send.str1 = text
        send.int1 = stringWidthP
        send.int2 = stringLengthP
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_PRNGETCHARSINWIDTH, send)
        If send.ret <> 0 Then
            stringWidthP = send.int1
            stringLengthP = send.int2
            If send.int3 = 1 Then
                fitWithinWidth = True
            Else
                fitWithinWidth = False
            End If
            PrnGetCharsInWidth = True
        Else
            PrnGetCharsInWidth = False
        End If
    End Function

    Public Function PrnGetCharsWidth(ByRef text As String) As Short
        Dim R As Boolean
        send.str1 = text
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_PRNGETCHARSWIDTH, send)
        If send.ret <> 0 Then
            PrnGetCharsWidth = send.int1
        Else
            PrnGetCharsWidth = 0
        End If
    End Function

    Public Function PrnGetTextMode() As Short
        Dim R As Boolean
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_PRNGETTEXTMODE, send)
        If send.ret <> 0 Then
            PrnGetTextMode = send.int1
        Else
            PrnGetTextMode = 0
        End If
    End Function

    Public Function PrnSetTextMode(ByRef mode As Short) As Boolean
        Dim R As Boolean
        send.int1 = mode
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_PRNSETTEXTMODE, send)
        If send.ret <> 0 Then
            PrnSetTextMode = True
        Else
            PrnSetTextMode = False
        End If
    End Function

    Public Function PrnEndPage() As Boolean
        Dim R As Boolean
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_PRNENDPAGE, send)
        If send.ret <> 0 Then
            PrnEndPage = True
        Else
            PrnEndPage = False
        End If
    End Function

    Public Function PrnSetFont(ByRef font As Short) As Boolean
        Dim R As Boolean

        send.int1 = font
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_PRNSETFONT, send)
        If send.ret <> 0 Then
            PrnSetFont = True
        Else
            PrnSetFont = False
        End If
    End Function

    Public Function ScreenInfo(ByRef width As Short, ByRef height As Short, ByRef depth As Short) As Boolean
        Dim R As Boolean
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_SCREENINFO, send)
        If send.ret <> 0 Then
            width = send.int1
            height = send.int2
            depth = send.int3
            ScreenInfo = True
        Else
            ScreenInfo = False
        End If
    End Function

    Public Function LineFeedX(ByRef lines As Short) As Boolean
        Dim R As Boolean
        send.int1 = lines
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_LINEFEEDX, send)
        If send.ret <> 0 Then
            LineFeedX = True
        Else
            LineFeedX = False
        End If
    End Function

    Public Function PPBarcodeRead(ByRef bartype As Short, ByRef barcode As String) As Short
        Dim R As Boolean

        send.str1 = "                                                                                                                                                      "
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_PPBARCODEREAD, send)

        PPBarcodeRead = send.ret
        If send.ret = PPBarErrNone Then
            bartype = send.int1
            barcode = send.str1
        End If
    End Function

    Public Function GetPrinterCapabilities(ByRef num As Short) As Short
        Dim R As Boolean
        send.int1 = num
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_GETPRINTERCAPABILITIES, send)

        GetPrinterCapabilities = send.ret
    End Function

    Public Function GetPrinterType() As Short
        Dim R As Boolean
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_GETPRINTERTYPE, send)

        GetPrinterType = send.ret
    End Function

    Public Function SetPrinterType(ByRef printer As Short) As Boolean
        Dim R As Boolean
        send.int1 = printer
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_SETPRINTERTYPE, send)

        If send.ret <> 0 Then
            SetPrinterType = True
        Else
            SetPrinterType = False
        End If
    End Function

    Public Function GetConnectionType() As Short
        Dim R As Boolean
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_GETCONNECTIONTYPE, send)

        GetConnectionType = send.ret
    End Function

    Public Function SetConnectionType(ByRef connection As Short) As Boolean
        Dim R As Boolean

        send.int1 = connection
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_SETCONNECTIONTYPE, send)

        If send.ret <> 0 Then
            SetConnectionType = True
        Else
            SetConnectionType = False
        End If
    End Function

    Public Function GetConnectionSpeed() As Short
        Dim R As Boolean
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_GETCONNECTIONSPEED, send)

        GetConnectionSpeed = send.ret
    End Function

    Public Function SetConnectionSpeed(ByRef speed As Short) As Boolean
        Dim R As Boolean

        send.int1 = speed
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_SETCONNECTIONSPEED, send)

        If send.ret <> 0 Then
            SetConnectionSpeed = True
        Else
            SetConnectionSpeed = False
        End If
    End Function

    Public Function ChangePrinterSpeed(ByRef speed As Short) As Boolean
        Dim R As Boolean

        send.int1 = speed
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_CHANGEPRINTERSPEED, send)

        If send.ret <> 0 Then
            ChangePrinterSpeed = True
        Else
            ChangePrinterSpeed = False
        End If
    End Function

    Public Function DetectPrinter() As Boolean
        Dim R As Boolean
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_DETECTPRINTER, send)

        If send.ret <> 0 Then
            DetectPrinter = True
        Else
            DetectPrinter = False
        End If
    End Function

    Public Function GetStatus(ByRef statcmd As Short) As Short
        Dim R As Boolean

        send.int1 = statcmd
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_GETSTATUS, send)

        GetStatus = send.ret
    End Function

    Public Function SetLeftMargin(ByRef margin As Short) As Boolean
        Dim R As Boolean

        send.int1 = margin
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_SETLEFTMARGIN, send)

        If send.ret <> 0 Then
            SetLeftMargin = True
        Else
            SetLeftMargin = False
        End If
    End Function

    Public Function ControlPanel(ByRef flags As Short) As Boolean
        Dim R As Boolean

        send.int1 = flags
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_CONTROLPANEL, send)

        If send.ret <> 0 Then
            ControlPanel = True
        Else
            ControlPanel = False
        End If
    End Function

    Public Function ResetDefaults(ByRef flags As Short) As Boolean
        Dim R As Boolean

        send.int1 = flags
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_RESETDEFAULTS, send)

        If send.ret <> 0 Then
            ResetDefaults = True
        Else
            ResetDefaults = False
        End If
    End Function

    Public Function SetLineSpace(ByRef linespace As Short) As Boolean
        Dim R As Boolean

        send.int1 = linespace
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_SETLINESPACE, send)

        If send.ret <> 0 Then
            SetLineSpace = True
        Else
            SetLineSpace = False
        End If
    End Function

    Public Function SetFontDoubleHeight(ByRef doubleheight As Boolean) As Boolean
        Dim R As Boolean

        If doubleheight = True Then
            send.int1 = 1
        Else
            send.int1 = 0
        End If

        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_SETFONTDOUBLEHEIGHT, send)

        If send.ret <> 0 Then
            SetFontDoubleHeight = True
        Else
            SetFontDoubleHeight = False
        End If
    End Function

    Public Function SetFontDoubleWidth(ByRef doublewidth As Boolean) As Boolean
        Dim R As Boolean

        If doublewidth = True Then
            send.int1 = 1
        Else
            send.int1 = 0
        End If

        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_SETFONTDOUBLEWIDTH, send)

        If send.ret <> 0 Then
            SetFontDoubleWidth = True
        Else
            SetFontDoubleWidth = False
        End If
    End Function

    Public Function PrintTextEx(ByRef text As String, ByRef flags As Short) As Boolean
        Dim R As Boolean

        send.str1 = text
        send.int1 = flags
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_PRINTTEXTEX, send)

        If send.ret <> 0 Then
            PrintTextEx = True
        Else
            PrintTextEx = False
        End If
    End Function

    Public Function SetItalic(ByRef italic As Boolean) As Boolean
        Dim R As Boolean

        If italic = True Then
            send.int1 = 1
        Else
            send.int1 = 0
        End If

        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_SETITALIC, send)

        If send.ret <> 0 Then
            SetItalic = True
        Else
            SetItalic = False
        End If
    End Function

    Public Function SetRowBorders(ByRef border As Short, ByRef symbol As String) As Boolean
        Dim R As Boolean

        send.int1 = border
        send.str1 = symbol
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_SETROWBORDERS, send)

        If send.ret <> 0 Then
            SetRowBorders = True
        Else
            SetRowBorders = False
        End If
    End Function

    Public Function LoadCustomBorderSet(ByRef setid As Short) As Boolean
        Dim R As Boolean

        send.int1 = setid
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_LOADCUSTOMBORDERSET, send)

        If send.ret <> 0 Then
            LoadCustomBorderSet = True
        Else
            LoadCustomBorderSet = False
        End If
    End Function

    Public Function StartTable(ByRef flags As Short) As Boolean
        Dim R As Boolean

        send.int1 = flags
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_STARTTABLE, send)

        If send.ret <> 0 Then
            StartTable = True
        Else
            StartTable = False
        End If
    End Function

    Public Function StartRow(ByRef ncolumns As Short, ByRef flags As Short) As Boolean
        Dim R As Boolean

        send.int1 = ncolumns
        send.int2 = flags
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_STARTROW, send)

        If send.ret <> 0 Then
            StartRow = True
        Else
            StartRow = False
        End If
    End Function

    Public Function SetCol(ByRef colindex As Short, ByRef length As Short, ByRef flags As Short) As Boolean
        Dim R As Boolean

        send.int1 = colindex
        send.int2 = length
        send.int3 = flags
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_SETCOL, send)

        If send.ret <> 0 Then
            SetCol = True
        Else
            SetCol = False
        End If
    End Function

    Public Function FillCol(ByRef colindex As Short, ByRef text As String) As Boolean
        Dim R As Boolean

        send.int1 = colindex
        send.str1 = text
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_FILLCOL, send)

        If send.ret <> 0 Then
            FillCol = True
        Else
            FillCol = False
        End If
    End Function

    Public Function EndRow() As Boolean
        Dim R As Boolean

        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_ENDROW, send)

        If send.ret <> 0 Then
            EndRow = True
        Else
            EndRow = False
        End If
    End Function

    Public Function EndTable() As Boolean
        Dim R As Boolean

        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_ENDTABLE, send)

        If send.ret <> 0 Then
            EndTable = True
        Else
            EndTable = False
        End If
    End Function

    Public Function FillColInt(ByRef colindex As Short, ByRef num As Short, ByRef minlen As Short) As Boolean
        Dim R As Boolean

        send.int1 = colindex
        send.int2 = num
        send.int3 = minlen
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_FILLCOLINT, send)

        If send.ret <> 0 Then
            FillColInt = True
        Else
            FillColInt = False
        End If
    End Function

    Public Function FillColDouble(ByRef colindex As Short, ByRef num As Double, ByRef round As Short, ByRef minlen As Short) As Boolean
        Dim R As Boolean

        send.int1 = colindex
        send.dbl1 = num
        send.int2 = round
        send.int3 = minlen
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_FILLCOLDOUBLE, send)

        If send.ret <> 0 Then
            FillColDouble = True
        Else
            FillColDouble = False
        End If
    End Function

    Public Function GetROMSerialNumber(ByRef buffer As String) As Boolean
        Dim R As Boolean

        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_GETROMSERIALNUMBER, send)

        If send.ret <> 0 Then
            buffer = send.str1
            GetROMSerialNumber = True
        Else
            GetROMSerialNumber = False
        End If
    End Function

    Public Function BarcodeType2Text(ByRef bartype As Short) As String
        Dim R As Boolean

        send.int1 = bartype
        send.str1 = "                                                                                                                                                      "
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_BARCODETYPE2TEXT, send)

        If send.ret <> 0 Then
            BarcodeType2Text = send.str1
        Else
            BarcodeType2Text = ""
        End If
    End Function

    Public Function GetLibraryInfo(ByRef param As Short) As Short
        Dim R As Boolean

        send.int1 = param
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_GETLIBRARYINFO, send)

        GetLibraryInfo = send.ret
    End Function

    Public Function PPBarcodeGetParam(ByRef param As Short) As Short
        Dim R As Boolean

        send.int1 = param
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_PPBARCODEGETPARAM, send)

        PPBarcodeGetParam = send.ret
    End Function

    'UPGRADE_NOTE: val was upgraded to val_Renamed. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1061"'
    Public Function PPBarcodeSetParam(ByRef param As Short, ByRef val_Renamed As Short) As Boolean
        Dim R As Boolean

        send.int1 = param
        send.int2 = val_Renamed
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_PPBARCODESETPARAM, send)

        If send.ret <> 0 Then
            PPBarcodeSetParam = True
        Else
            PPBarcodeSetParam = False
        End If
    End Function

    Public Function PPBarcodeControlPanel(ByRef flags As Short) As Boolean
        Dim R As Boolean

        send.int1 = flags
        'UPGRADE_ISSUE: VarPtr function is not supported. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1040"'
        R = PalmOSFunctionsLibafPalmOS_definst.CallApp("AppForgeSDK", DP_PPBARCODECONTROLPANEL, send)

        If send.ret <> 0 Then
            PPBarcodeControlPanel = True
        Else
            PPBarcodeControlPanel = False
        End If
    End Function
End Module