'THIS SDK IS FOR APPFORGE MOBILEVB ONLY

Attribute VB_Name = "AppForgePPSDK"
Option Explicit

'true/false constants
Public Const DPTRUE = 1
Public Const DPFALSE = 0

'underline modes
Public Const PRNnoUnderline = 0
Public Const PRNgrayUnderline = 1
Public Const PRNsolidUnderline = 2
Public Const PRNcolorUnderline = 3

'palmos standart fonts
Public Const PRNstdFont = 0
Public Const PRNboldFont = 1
Public Const PRNlargeFont = 2
Public Const PRNsymbolFont = 3
Public Const PRNsymbol11Font = 4
Public Const PRNsymbol7Font = 5
Public Const PRNledFont = 6
Public Const PRNlargeBoldFont = 7
Public Const PRNfntAppFontCustomBase = 128

'GetLibraryInfo params
Public Const INFO_RELEASE = 0
Public Const INFO_BUILD = 1
Public Const INFO_STAGE = 2
Public Const INFO_ISDEBUG = 3

'GetLibraryInfo stage values
Public Const STAGE_PREVIEW = 0
Public Const STAGE_ALPHA = 1
Public Const STAGE_BETA = 2
Public Const STAGE_GAMMA = 3
Public Const STAGE_RC = 4
Public Const STAGE_FINAL = 5

'Printer Types
Public Const PP50 = 0
Public Const PP55 = 1
Public Const CMP10 = 2

'Connection Types
Public Const CONSERIAL = 0
Public Const CONUSB = 1

'Speed Settings
Public Const Speed1200 = 0
Public Const Speed2400 = 1
Public Const Speed4800 = 2
Public Const Speed9600 = 3
Public Const Speed19200 = 4
Public Const Speed38400 = 5
Public Const Speed57600 = 6
Public Const Speed115200 = 7

'Intensity Levels
Public Const Intensity70 = 0
Public Const Intensity80 = 1
Public Const Intensity90 = 2
Public Const Intensity100 = 3
Public Const Intensity120 = 4
Public Const Intensity150 = 5

'Internal Font Types
Public Const FontLarge = 0
Public Const FontSmall = 1

'Print Barcode Types
Public Const Bar_UPCA = 0
Public Const Bar_UPCE = 1
Public Const Bar_EAN13 = 2
Public Const Bar_EAN8 = 3
Public Const Bar_CODE39 = 4
Public Const Bar_ITF = 5
Public Const Bar_CODABAR = 6
Public Const Bar_CODE93 = 7
Public Const Bar_CODE128 = 8
Public Const Bar_PDF417 = 9

'GetStatus commands
Public Const STAT_ISCONNECTED = 0
Public Const STAT_GETBATVOLT = 1
Public Const STAT_GETBATPERCENT = 2
Public Const STAT_GETTEMPC = 3
Public Const STAT_GETTEMPFR = 4
Public Const STAT_HASPAPER = 5
Public Const STAT_GETVERSION = 6
Public Const STAT_GETTYPE = 7
Public Const STAT_GETCONNECTION = 8
Public Const STAT_GETSPEED = 9

'GetStatus result codes
Public Const StatErrNotImpl = -1
Public Const StatErrNotConnected = -2

'Barcode Parameters
Public Const BeeperTone = &H91
Public Const SessionTime = &H88
Public Const BeepAfterGoodDecode = &H38
Public Const LinearCodeTypeSecurityLevel = &H4E
Public Const EnableUPCA = &H1
Public Const EnableUPCE = &H2
Public Const EnableUPCE1 = &HC
Public Const EnableEAN8 = &H4
Public Const EnableEAN13 = &H3
Public Const EnableBooklandEAN = &H53
Public Const TransmitUPCACheckDigit = &H28
Public Const TransmitUPCECheckDigit = &H29
Public Const TransmitUPCE1CheckDigit = &H2A
Public Const UPCAPreamble = &H22
Public Const UPCEPreamble = &H23
Public Const UPCE1Preamble = &H24
Public Const ConvertUPCEtoA = &H25
Public Const ConvertUPCE1toA = &H26
Public Const EAN8ZeroExtend = &H27
Public Const ConvertEAN8toEAN13 = &HE0
Public Const UPCEANSecurityLevel = &H4D
Public Const UPCEANCouponCode = &H55
Public Const EnableCode128 = &H8
Public Const EnableUCCEAN128 = &HE
Public Const EnableCode39 = &H0
Public Const EnableTriopticCode39 = &HD
Public Const ConvertCode39toCode32 = &H56
Public Const TransmitCode39CheckDigit = &H2B
Public Const Code39FullASCIIConversion = &H11
Public Const EnableCode93 = &H9
Public Const EnableInterleaved2of5 = &H6
Public Const TransmitI2of5CheckDigit = &H2C
Public Const ConvertI2of5toEAN13 = &H52
Public Const EnableDiscrete2of5 = &H5
Public Const EnableCodabar = &H7
Public Const EnableMSIPlessey = &HB
Public Const TransmitMSIPlesseyCheckDigit = &H2E
Public Const EnableCode11 = &HA
Public Const EnableWebcode = &HF076
Public Const EnableGTWebcode = &HF079

'Barcode Types
Public Const Bookland = &H16
Public Const Codabar = &H2
Public Const Code11 = &HC
Public Const Code32 = &H20
Public Const Code128 = &H3
Public Const Code39 = &H1
Public Const Code39_FullASCII = &H13
Public Const Code93 = &H7
Public Const Composite = &H1D
Public Const Coupon = &H17
Public Const D25 = &H4
Public Const DataMatrix = &H1B
Public Const EAN_128 = &HF
Public Const EAN_13 = &HB
Public Const EAN_13_plus_2 = &H4B
Public Const EAN_13_plus_5 = &H8B
Public Const EAN_8 = &HA
Public Const EAN_8_plus_2 = &H4A
Public Const EAN_8_plus_5 = &H8A
Public Const IATA = &H5
Public Const ISBT_128 = &H19
Public Const ISBT_128_concateneted = &H21
Public Const ITF = &H6
Public Const MacroPDF = &H28
Public Const MSI = &HE
Public Const PDF_417 = &H11
Public Const Postbar_Canada = &H26
Public Const Postnet_US = &H1E
Public Const Postal_Australia = &H23
Public Const Postal_Japan = &H22
Public Const Postal_UK = &H27
Public Const QR_code = &H1C
Public Const RSS_limited = &H31
Public Const RSS_14 = &H30
Public Const RSS_Expanded = &H32
Public Const Signature = &H24
Public Const TriopticCode39 = &H15
Public Const UPCA = &H8
Public Const UPCA_plus_2 = &H48
Public Const UPCA_plus_5 = &H88
Public Const UPCE = &H9
Public Const UPCE_plus_2 = &H49
Public Const UPCE_plus_5 = &H89
Public Const UPCE1 = &H10
Public Const UPCE1_plus_2 = &H50
Public Const UPCE1_plus_5 = &H90

'Barcode Functions Result codes
Public Const PPBarErrNone = 0
Public Const PPBarErrNoBar = 1
Public Const PPBarErrFailed = 2
Public Const PPBarErrWrongArguments = 3

'ResetDefaults Flags
Public Const Reset_PrintSettings = 1
Public Const Reset_FontSettings = 2
Public Const Reset_BarcodeSettings = 4
Public Const Reset_DontSetPrinter = &H80

'PrintTextEx Flags
Public Const Text_Italic = 1
Public Const Text_Bold = 2
Public Const Text_Underlined = 4
Public Const Text_DoubleWidth = 8
Public Const Text_DoubleHeight = 16
Public Const Text_Rotated = 32
Public Const Text_Reversed = 64

Public Const Text_AlignMask = 512 + 256
Public Const Text_AlignLeft = 0
Public Const Text_AlignCenter = 256
Public Const Text_AlignRight = 512

Public Const Text_BigFont = 0
Public Const Text_SmallFont = 1024

Public Const Text_DontLF = 2048
Public Const Text_WordWrap = 4096

Public Const Text_UseOldSettings = 8192
Public Const Text_SaveSettings = 16384

'TABLE DEFINES
'Table - Column flags
Public Const COL_BOLD = 1
Public Const COL_ITALIC = 2
Public Const COL_SMALL = 4
Public Const COL_UNDERLINE = 8
Public Const COL_DOUBLWIDTH = 16
Public Const COL_DOUBLHEIGHT = 32
Public Const COL_INVERT = 64

Public Const COL_ALIGN_MASK = 768
Public Const COL_LEFT = 0
Public Const COL_CENTER = 256
Public Const COL_RIGHT = 512

Public Const COL_BORIN = 16

'Table - Row flags
Public Const ROW_BORLEFT = 1
Public Const ROW_BORINH = 2
Public Const ROW_BORINV = 4
Public Const ROW_BORRIGHT = 8
Public Const ROW_BORTOP = 16
Public Const ROW_BORBOTTOM = 32
Public Const ROW_BORALL = ROW_BORLEFT + ROW_BORINV + ROW_BORRIGHT + ROW_BORTOP + ROW_BORBOTTOM
Public Const ROW_BORSTART = ROW_BORLEFT + ROW_BORINH + ROW_BORINV + ROW_BORRIGHT + ROW_BORTOP
Public Const ROW_BORSTD = ROW_BORLEFT + ROW_BORINV + ROW_BORRIGHT
Public Const ROW_BOREND = ROW_BORLEFT + ROW_BORINV + ROW_BORRIGHT + ROW_BORBOTTOM

'Table - flags
Public Const TBL_USECUSTOMBORDERS = 128

'Table - Borders selection
Public Const BORDER_TOPLEFT = 0
Public Const BORDER_TOP = 1
Public Const BORDER_TOPRIGHT = 2
Public Const BORDER_LEFT = 3
Public Const BORDER_LEFTSMALL = 3
Public Const BORDER_LEFTBIG = 4
Public Const BORDER_RIGHT = 5
Public Const BORDER_RIGHTSMALL = 5
Public Const BORDER_RIGHTBIG = 6
Public Const BORDER_BOTTOMLEFT = 7
Public Const BORDER_BOTTOM = 8
Public Const BORDER_BOTTOMRIGHT = 9
Public Const BORDER_INSIDEH = 10
Public Const BORDER_INSIDEV = 11
Public Const BORDER_INSIDEVSMALL = 11
Public Const BORDER_INSIDEVBIG = 12
Public Const BORDER_INSIDECROSS = 13
Public Const BORDER_TOPINSIDE = 14
Public Const BORDER_BOTTOMINSIDE = 15
Public Const BORDER_LEFTINSIDE = 16
Public Const BORDER_RIGHTINSIDE = 17

'Table - Custom Table Sets
Public Const TBL_DOTS = 0
Public Const TBL_PARAGRAPH = 1
Public Const TBL_SPIDER = 2
Public Const TBL_STANDART = 3
Public Const TBL_STANDARTHF = 4
Public Const TBL_STANDART_SHADOW = 5
Public Const TBL_STANDART_SMOOTHHF = 6
Public Const TBL_SMOOTH = 7
Public Const TBL_WAVY = 8
Public Const TBL_WAVY_SHADOW = 9

'PrnDrawText flags
Public Const prnDrawTextLeft = &H1
Public Const prnDrawTextCenter = &H2
Public Const prnDrawTextRight = &H4
Public Const prnDrawTextBottom = &H10
Public Const prnDrawTextVCenter = &H20
Public Const prnDrawTextTop = &H40
Public Const prnDrawTextSingleLine = &H100
Public Const prnDrawTextMultiLine = &H200
Public Const prnDrawTextUInt16Break = &H400
Public Const prnDrawTextClip = &H1000
Public Const prnDrawTextNoClip = &H2000

Public Const prnDrawTextHorzAlignMask = &HF
Public Const prnDrawTextVertAlignMask = &HF0
Public Const prnDrawTextLineFormatMask = &HF00
Public Const prnDrawTextClippingMask = &HF000


'PalmOS internal fonts
Public Const PALM_stdFont = 0
Public Const PALM_boldFont = 1
Public Const PALM_largeFont = 2
Public Const PALM_symbolFont = 3
Public Const PALM_symbol11Font = 4
Public Const PALM_symbol7Font = 5
Public Const PALM_ledFont = 6
Public Const PALM_largeBoldFont = 7
Public Const PALM_fntAppFontCustomBase = 128

'PalmOS internal draw modes
Public Const PALM_winPaint = 0
Public Const PALM_winErase = 1
Public Const PALM_winMask = 2
Public Const PALM_winInvert = 3
Public Const PALM_winOverlay = 4
Public Const PALM_winPaintInverse = 5
Public Const PALM_winSwap = 6

'PalmOS underline modes
Public Const PALM_noUnderline = 0
Public Const PALM_grayUnderline = 1
Public Const PALM_solidUnderline = 2
Public Const PALM_colorUnderline = 3


'================================================================================='
Private Const DP_INITPRINTER = 1 + 32768
Private Const DP_DONEPRINTER = 2 + 32768

Private Const DP_LINEFEED = 10 + 32768
Private Const DP_SELFTEST = 11 + 32768
Private Const DP_PRINTTEXT = 12 + 32768
Private Const DP_PRINTTEXTWRAPPED = 13 + 32768
Private Const DP_PRINTBARCODE = 14 + 32768
Private Const DP_PRINTBUFFER = 15 + 32768
Private Const DP_PRINTIMAGE = 16 + 32768
Private Const DP_PRINTLOGO = 17 + 32768
Private Const DP_PRINTSCREEN = 18 + 32768
Private Const DP_PRINTBARCODEN = 19 + 32768

Private Const DP_SETALIGN = 20 + 32768
Private Const DP_SETAUTOLINEFEED = 21 + 32768
Private Const DP_SETBOLD = 22 + 32768
Private Const DP_SETBARCODESCALE = 23 + 32768
Private Const DP_SETBARCODEHEIGHT = 24 + 32768
Private Const DP_SETBARCODETEXT = 25 + 32768
Private Const DP_SETINTENSITY = 26 + 32768
Private Const DP_SETFONT = 27 + 32768
Private Const DP_SETUNDERLINE = 28 + 32768
Private Const DP_SET90DEGREE = 29 + 32768
Private Const DP_SETREVERSE = 30 + 32768
Private Const DP_SETBARCODEALIGN = 31 + 32768

Private Const DP_GETPRINTVER = 39 + 32768
Private Const DP_GETLASTERROR = 40 + 32768
Private Const DP_GETBATTERY = 41 + 32768
Private Const DP_GETTEMPERATURE = 42 + 32768

Private Const DP_UPLOADLOGO = 43 + 32768

Private Const DP_TEXTSTART = 44 + 32768
Private Const DP_TEXTEND = 45 + 32768
Private Const DP_TEXTOUT = 46 + 32768
Private Const DP_TEXTOUTN = 47 + 32768
Private Const DP_TEXTCHARSPACE = 48 + 32768
Private Const DP_TEXTFONT = 49 + 32768
Private Const DP_TEXTUNDERLINE = 50 + 32768
Private Const DP_TEXTBOLD = 51 + 32768
Private Const DP_TEXT90DEGREE = 52 + 32768
Private Const DP_TEXTINTENSITY = 53 + 32768
Private Const DP_TEXTALIGN = 54 + 32768
Private Const DP_TEXT180DEGREE = 55 + 32768
Private Const DP_GETRELEASE = 56 + 32768
Private Const DP_READCARDTRACKS = 57 + 32768
Private Const DP_READPAYMENTCARD = 58 + 32768
Private Const DP_SETIMAGESETTINGS = 59 + 32768
Private Const DP_SCREENCAPTURE = 60 + 32768
Private Const DP_READBARCODE = 61 + 32768
Private Const DP_PRINTBITMAP = 62 + 32768

Private Const DP_PRINTBITMAPNEW = 63 + 32768

Private Const DP_REGISTER = 64 + 32768
Private Const DP_EXTOPENCONNECTION = 65 + 32768
Private Const DP_EXTSENDDATA = 66 + 32768
Private Const DP_EXTRECEIVEDATA = 67 + 32768
Private Const DP_EXTRECEIVEDATASTOP = 68 + 32768
Private Const DP_EXTCLOSECONNECTION = 69 + 32768
Private Const DP_EXTGETDTR = 70 + 32768
Private Const DP_EXTSETDTR = 71 + 32768
Private Const DP_EXTGETRTS = 72 + 32768
Private Const DP_EXTGETCTS = 73 + 32768
Private Const DP_EXTGETDSR = 74 + 32768
Private Const DP_EXTGETBREAK = 75 + 32768
Private Const DP_EXTSETBREAK = 76 + 32768

Private Const DP_PRNSTARTPAGE = 77 + 32768
Private Const DP_PRNCLOSE = 78 + 32768
Private Const DP_PRNDRAWBITMAP = 79 + 32768
Private Const DP_PRNDRAWCHARS = 80 + 32768
Private Const DP_PRNDRAWTRUNCCHARS = 81 + 32768
Private Const DP_PRNDRAWGRAYLINE = 82 + 32768
Private Const DP_PRNDRAWGRAYRECTANGLE = 83 + 32768
Private Const DP_PRNFILLRECTANGLE = 84 + 32768
Private Const DP_PRNDRAWGRAYRECTANGLEFRAME = 85 + 32768
Private Const DP_PRNDRAWLINE = 86 + 32768
Private Const DP_PRNDRAWRECTANGLE = 87 + 32768
Private Const DP_PRNDRAWRECTANGLEFRAME = 88 + 32768
Private Const DP_PRNDRAWTEXT = 89 + 32768
Private Const DP_PRNGETFONT = 90 + 32768
Private Const DP_PRNGETPAGEEXTENT = 91 + 32768
Private Const DP_PRNGETPATTERN = 92 + 32768
Private Const DP_PRNGETUNDERLINEMODE = 93 + 32768
Private Const DP_PRNENDPAGE = 94 + 32768
Private Const DP_PRNSETFONT = 95 + 32768
Private Const DP_PRNSETPATTERN = 96 + 32768
Private Const DP_PRNSETUNDERLINEMODE = 97 + 32768
Private Const DP_PRNGETAVARAGECHARWIDTH = 98 + 32768
Private Const DP_PRNGETCHARHEIGHT = 99 + 32768
Private Const DP_PRNGETCHARWIDTH = 100 + 32768
Private Const DP_PRNGETCHARSINWIDTH = 101 + 32768
Private Const DP_PRNGETCHARSWIDTH = 102 + 32768
Private Const DP_PRNSETTEXTMODE = 103 + 32768
Private Const DP_PRNGETTEXTMODE = 104 + 32768

Private Const DP_SCREENINFO = 105 + 32768

Private Const DP_LINEFEEDX = 106 + 32768
Private Const DP_PPBARCODEREAD = 107 + 32768
Private Const DP_GETPRINTERCAPABILITIES = 108 + 32768
Private Const DP_GETPRINTERTYPE = 109 + 32768
Private Const DP_SETPRINTERTYPE = 110 + 32768
Private Const DP_GETCONNECTIONTYPE = 111 + 32768
Private Const DP_SETCONNECTIONTYPE = 112 + 32768
Private Const DP_GETCONNECTIONSPEED = 113 + 32768
Private Const DP_SETCONNECTIONSPEED = 114 + 32768
Private Const DP_CHANGEPRINTERSPEED = 115 + 32768
Private Const DP_DETECTPRINTER = 116 + 32768
Private Const DP_GETSTATUS = 117 + 32768
Private Const DP_SETLEFTMARGIN = 118 + 32768
Private Const DP_PROCESSPAYMENTCARDDATA = 119 + 32768
Private Const DP_PROCESSPAYMENTCARDTRACKS = 120 + 32768
Private Const DP_CONTROLPANEL = 121 + 32768
Private Const DP_RESETDEFAULTS = 122 + 32768
Private Const DP_SETLINESPACE = 123 + 32768
Private Const DP_SETFONTDOUBLEHEIGHT = 124 + 32768
Private Const DP_SETFONTDOUBLEWIDTH = 125 + 32768
Private Const DP_PRINTTEXTEX = 126 + 32768
Private Const DP_SETITALIC = 127 + 32768
Private Const DP_SETROWBORDERS = 128 + 32768
Private Const DP_SETCUSTOMROWBORDERS = 129 + 32768
Private Const DP_LOADCUSTOMBORDERSET = 130 + 32768
Private Const DP_STARTTABLE = 131 + 32768
Private Const DP_STARTROW = 132 + 32768
Private Const DP_SETCOL = 133 + 32768
Private Const DP_FILLCOL = 134 + 32768
Private Const DP_ENDROW = 135 + 32768
Private Const DP_ENDTABLE = 136 + 32768
Private Const DP_FILLCOLINT = 137 + 32768
Private Const DP_FILLCOLDOUBLE = 138 + 32768
Private Const DP_GETROMSERIALNUMBER = 139 + 32768
Private Const DP_BARCODETYPE2TEXT = 140 + 32768
Private Const DP_GETLIBRARYINFO = 141 + 32768
Private Const DP_PPBARCODEGETPARAM = 142 + 32768
Private Const DP_PPBARCODESETPARAM = 143 + 32768
Private Const DP_PPBARCODECONTROLPANEL = 144 + 32768

Private Type TSend
    str1 As String
    str2 As String
    str3 As String
    
    int1 As Long
    int2 As Long
    int3 As Long
    int4 As Long
    int5 As Long
    
    buffer As Long
    ret As Long
    
    dbl1 As Double
End Type

Dim send As TSend



    

Public Function InitPrinter() As Boolean
    Dim R As Boolean
    R = afPalmOS.CallApp("AppForgeSDK", DP_INITPRINTER, VarPtr(send))
    If send.ret <> 0 Then
        InitPrinter = True
    Else:
        InitPrinter = False
    End If
End Function

Public Function DonePrinter() As Boolean
    Dim R As Boolean
    R = afPalmOS.CallApp("AppForgeSDK", DP_DONEPRINTER, VarPtr(send))
    If send.ret <> 0 Then
        DonePrinter = True
    Else:
        DonePrinter = False
    End If
End Function

Public Function LineFeed() As Boolean
    Dim R As Boolean
    R = afPalmOS.CallApp("AppForgeSDK", DP_LINEFEED, VarPtr(send))
    If send.ret <> 0 Then
        LineFeed = True
    Else:
        LineFeed = False
    End If
End Function

Public Function PrintText(ByVal text As String) As Boolean
    Dim R As Boolean
    
    send.str1 = text
    R = afPalmOS.CallApp("AppForgeSDK", DP_PRINTTEXT, VarPtr(send))
    If send.ret <> 0 Then
        PrintText = True
    Else:
        PrintText = False
    End If
End Function

Public Function SelfTest(longtest As Boolean) As Boolean
    Dim R As Boolean
    If longtest = True Then
        send.int1 = 1
    Else:
        send.int1 = 0
    End If
    R = afPalmOS.CallApp("AppForgeSDK", DP_SELFTEST, VarPtr(send))
    If send.ret <> 0 Then
        SelfTest = True
    Else:
        SelfTest = False
    End If
End Function

Public Function PrintTextWrapped(ByVal text As String) As Boolean
    Dim R As Boolean
    send.str1 = text
    R = afPalmOS.CallApp("AppForgeSDK", DP_PRINTTEXTWRAPPED, VarPtr(send))
    If send.ret <> 0 Then
        PrintTextWrapped = True
    Else:
        PrintTextWrapped = False
    End If
End Function

Public Function PrintBarcode(bartype As Integer, ByVal barcode As String) As Boolean
    Dim R As Boolean
    send.str1 = barcode
    send.int1 = bartype
    R = afPalmOS.CallApp("AppForgeSDK", DP_PRINTBARCODE, VarPtr(send))
    If send.ret <> 0 Then
        PrintBarcode = True
    Else:
        PrintBarcode = False
    End If
End Function

Public Function PrintBarcodeN(bartype As Integer, ByVal barcode As String, barlen As Integer) As Boolean
    Dim R As Boolean
    send.int1 = bartype
    send.str1 = barcode
    send.int2 = barlen
    R = afPalmOS.CallApp("AppForgeSDK", DP_PRINTBARCODEN, VarPtr(send))
    If send.ret <> 0 Then
        PrintBarcodeN = True
    Else:
        PrintBarcodeN = False
    End If
End Function

Public Function PrintBuffer(ByVal buf As String, size As Integer) As Boolean
    Dim R As Boolean
    send.str1 = buf
    send.int1 = size
    R = afPalmOS.CallApp("AppForgeSDK", DP_PRINTBUFFER, VarPtr(send))
    If send.ret <> 0 Then
        PrintBuffer = True
    Else:
        PrintBuffer = False
    End If
End Function

Public Function PrintImage(x As Integer, y As Integer, bufpointer As Long) As Boolean
    Dim R As Boolean
    send.buffer = bufpointer
    send.int1 = x
    send.int2 = y
    R = afPalmOS.CallApp("AppForgeSDK", DP_PRINTIMAGE, VarPtr(send))
    If send.ret <> 0 Then
        PrintImage = True
    Else:
        PrintImage = False
    End If
End Function

Public Function UploadLogo(ByVal file As String) As Boolean
    Dim R As Boolean
    send.str1 = file
    send.int1 = 0
    R = afPalmOS.CallApp("AppForgeSDK", DP_UPLOADLOGO, VarPtr(send))
    If send.ret <> 0 Then
        UploadLogo = True
    Else:
        UploadLogo = False
    End If
End Function

Public Function PrintLogo(mode As Integer) As Boolean
    Dim R As Boolean
    send.int1 = mode
    R = afPalmOS.CallApp("AppForgeSDK", DP_PRINTLOGO, VarPtr(send))
    If send.ret <> 0 Then
        PrintLogo = True
    Else:
        PrintLogo = False
    End If
End Function

Public Function SetImageSettings(brightenabled As Boolean, brightness As Integer, contrastenabled As Boolean, contrast As Integer) As Boolean
    Dim R As Boolean
    If brightenabled = True Then
        send.int1 = 1
    Else:
        send.int1 = 0
    End If
    If contrastenabled = True Then
        send.int3 = 1
    Else:
        send.int3 = 0
    End If
    send.int2 = brightness
    send.int4 = contrast
    R = afPalmOS.CallApp("AppForgeSDK", DP_SETIMAGESETTINGS, VarPtr(send))
    If send.ret <> 0 Then
        SetImageSettings = True
    Else:
        SetImageSettings = False
    End If
End Function

Public Function PrintScreen(x As Integer, y As Integer, w As Integer, h As Integer, percent As Integer) As Boolean
    Dim R As Boolean
    send.int1 = x
    send.int2 = y
    send.int3 = w
    send.int4 = h
    send.int5 = percent
    R = afPalmOS.CallApp("AppForgeSDK", DP_PRINTSCREEN, VarPtr(send))
    If send.ret <> 0 Then
        PrintScreen = True
    Else:
        PrintScreen = False
    End If
End Function

Public Function ScreenCapture(x As Integer, y As Integer, w As Integer, h As Integer, percent As Integer, bufpointer As Long) As Boolean
    Dim R As Boolean
    send.int1 = x
    send.int2 = y
    send.int3 = w
    send.int4 = h
    send.int5 = percent
    send.buffer = bufpointer
    R = afPalmOS.CallApp("AppForgeSDK", DP_SCREENCAPTURE, VarPtr(send))
    If send.ret <> 0 Then
        ScreenCapture = True
    Else:
        ScreenCapture = False
    End If
End Function

Public Function SetAlign(align As Integer) As Boolean
    Dim R As Boolean
    send.int1 = align
    R = afPalmOS.CallApp("AppForgeSDK", DP_SETALIGN, VarPtr(send))
    If send.ret <> 0 Then
        SetAlign = True
    Else:
        SetAlign = False
    End If
End Function

Public Function SetAutoLineFeed(autolf As Boolean) As Boolean
    Dim R As Boolean
    If autolf = True Then
        send.int1 = 1
    Else:
        send.int1 = 0
    End If
    R = afPalmOS.CallApp("AppForgeSDK", DP_SETAUTOLINEFEED, VarPtr(send))
    If send.ret <> 0 Then
        SetAutoLineFeed = True
    Else:
        SetAutoLineFeed = False
    End If
End Function

Public Function SetBold(bold As Boolean) As Boolean
    Dim R As Boolean
    If bold = True Then
        send.int1 = 1
    Else:
        send.int1 = 0
    End If
    R = afPalmOS.CallApp("AppForgeSDK", DP_SETBOLD, VarPtr(send))
    If send.ret <> 0 Then
        SetBold = True
    Else:
        SetBold = False
    End If
End Function

Public Function SetBarcodeScale(barscale As Integer) As Boolean
    Dim R As Boolean
    send.int1 = barscale
    R = afPalmOS.CallApp("AppForgeSDK", DP_SETBARCODESCALE, VarPtr(send))
    If send.ret <> 0 Then
        SetBarcodeScale = True
    Else:
        SetBarcodeScale = False
    End If
End Function

Public Function SetBarcodeHeight(barheight As Integer) As Boolean
    Dim R As Boolean
    send.int1 = barheight
    R = afPalmOS.CallApp("AppForgeSDK", DP_SETBARCODEHEIGHT, VarPtr(send))
    If send.ret <> 0 Then
        SetBarcodeHeight = True
    Else:
        SetBarcodeHeight = False
    End If
End Function

Public Function SetBarcodeText(bartext As Integer) As Boolean
    Dim R As Boolean
    send.int1 = bartext
    R = afPalmOS.CallApp("AppForgeSDK", DP_SETBARCODETEXT, VarPtr(send))
    If send.ret <> 0 Then
        SetBarcodeText = True
    Else:
        SetBarcodeText = False
    End If
End Function

Public Function SetIntensity(intesity As Integer) As Boolean
    Dim R As Boolean
    send.int1 = intesity
    R = afPalmOS.CallApp("AppForgeSDK", DP_SETINTENSITY, VarPtr(send))
    If send.ret <> 0 Then
        SetIntensity = True
    Else:
        SetIntensity = False
    End If
End Function

Public Function SetFont(font As Integer) As Boolean
    Dim R As Boolean
    send.int1 = font
    R = afPalmOS.CallApp("AppForgeSDK", DP_SETFONT, VarPtr(send))
    If send.ret <> 0 Then
        SetFont = True
    Else:
        SetFont = False
    End If
End Function

Public Function SetUnderline(underline As Boolean) As Boolean
    Dim R As Boolean
    If underline = True Then
        send.int1 = 1
    Else:
        send.int1 = 0
    End If
    R = afPalmOS.CallApp("AppForgeSDK", DP_SETUNDERLINE, VarPtr(send))
    If send.ret <> 0 Then
        SetUnderline = True
    Else:
        SetUnderline = False
    End If
End Function

Public Function Set90degree(degree As Boolean) As Boolean
    Dim R As Boolean
    If degree = True Then
        send.int1 = 1
    Else:
        send.int1 = 0
    End If
    R = afPalmOS.CallApp("AppForgeSDK", DP_SET90DEGREE, VarPtr(send))
    If send.ret <> 0 Then
        Set90degree = True
    Else:
        Set90degree = False
    End If
End Function

Public Function SetReverse(reverse As Boolean) As Boolean
    Dim R As Boolean
    If reverse = True Then
        send.int1 = 1
    Else:
        send.int1 = 0
    End If
    R = afPalmOS.CallApp("AppForgeSDK", DP_SETREVERSE, VarPtr(send))
    If send.ret <> 0 Then
        SetReverse = True
    Else:
        SetReverse = False
    End If
End Function

Public Function SetBarcodeAlign(align As Integer) As Boolean
    Dim R As Boolean
    send.int1 = align
    R = afPalmOS.CallApp("AppForgeSDK", DP_SETBARCODEALIGN, VarPtr(send))
    If send.ret <> 0 Then
        SetBarcodeAlign = True
    Else:
        SetBarcodeAlign = False
    End If
End Function

Public Function GetBattery() As Integer
    Dim R As Boolean
    
    R = afPalmOS.CallApp("AppForgeSDK", DP_GETBATTERY, VarPtr(send))
    GetBattery = send.int1
End Function

Public Function GetTemperature() As Integer
    Dim R As Boolean
    
    R = afPalmOS.CallApp("AppForgeSDK", DP_GETTEMPERATURE, VarPtr(send))
    GetTemperature = send.int1
End Function

Public Function GetPrinterVersion() As Integer
    Dim R As Boolean
    
    R = afPalmOS.CallApp("AppForgeSDK", DP_GETPRINTVER, VarPtr(send))
    GetPrinterVersion = send.int1
End Function

Public Function GetRelease() As Integer
    Dim R As Boolean
    
    R = afPalmOS.CallApp("AppForgeSDK", DP_GETRELEASE, VarPtr(send))
    GetRelease = send.int1
End Function

Public Function ReadPaymentCard(name As String, number As String, year As Integer, month As Integer, timeoutsec As Integer) As Boolean
    Dim R As Boolean
    
    send.int3 = timeoutsec
    send.str1 = "                                                                                                                                                      "
    send.str2 = "                                                                                                                                                      "
    R = afPalmOS.CallApp("AppForgeSDK", DP_READPAYMENTCARD, VarPtr(send))
    If send.ret <> 0 Then
        name = send.str1
        number = send.str2
        month = send.int1
        year = send.int2
        If year > 80 And year < 99 Then
            year = year + 1900
        Else
            year = year + 2000
        End If
        ReadPaymentCard = True
    Else:
        ReadPaymentCard = False
    End If
End Function

Public Function ReadCardTracks(track1 As String, track2 As String, track3 As String, timeoutsec As Integer) As Boolean
    Dim R As Boolean
    
    send.int1 = timeoutsec
    send.str1 = "                                                                                                                                                      "
    send.str2 = "                                                                                                                                                      "
    send.str3 = "                                                                                                                                                      "
    R = afPalmOS.CallApp("AppForgeSDK", DP_READCARDTRACKS, VarPtr(send))
    If send.ret <> 0 Then
        track1 = send.str1
        track2 = send.str2
        track3 = send.str3
        ReadCardTracks = True
    Else:
        ReadCardTracks = False
    End If
End Function

Public Function TextStart() As Boolean
    Dim R As Boolean
    R = afPalmOS.CallApp("AppForgeSDK", DP_TEXTSTART, VarPtr(send))
    If send.ret <> 0 Then
        TextStart = True
    Else:
        TextStart = False
    End If
End Function

Public Function TextEnd() As Boolean
    Dim R As Boolean
    R = afPalmOS.CallApp("AppForgeSDK", DP_TEXTEND, VarPtr(send))
    If send.ret <> 0 Then
        TextEnd = True
    Else:
        TextEnd = False
    End If
End Function

Public Function TextOut(ByVal text As String) As Boolean
    Dim R As Boolean
    send.str1 = text
    R = afPalmOS.CallApp("AppForgeSDK", DP_TEXTOUT, VarPtr(send))
    If send.ret <> 0 Then
        TextOut = True
    Else:
        TextOut = False
    End If
End Function

Public Function TextOutN(ByVal text As String, length As Integer) As Boolean
    Dim R As Boolean
    send.str1 = text
    send.int1 = length
    R = afPalmOS.CallApp("AppForgeSDK", DP_TEXTOUTN, VarPtr(send))
    If send.ret <> 0 Then
        TextOutN = True
    Else:
        TextOutN = False
    End If
End Function

Public Function TextCharSpace(space As Integer) As Boolean
    Dim R As Boolean
    send.int1 = space
    R = afPalmOS.CallApp("AppForgeSDK", DP_TEXTCHARSPACE, VarPtr(send))
    If send.ret <> 0 Then
        TextCharSpace = True
    Else:
        TextCharSpace = False
    End If
End Function

Public Function TextFont(big As Boolean, bold As Boolean, doubleheight As Boolean, doublewidth As Boolean, underline As Boolean) As Boolean
    Dim R As Boolean
    If big = True Then
        send.int1 = 1
    Else:
        send.int1 = 0
    End If
    If bold = True Then
        send.int2 = 1
    Else:
        send.int2 = 0
    End If
    If doubleheight = True Then
        send.int3 = 1
    Else:
        send.int3 = 0
    End If
    If doublewidth = True Then
        send.int4 = 1
    Else:
        send.int4 = 0
    End If
    If underline = True Then
        send.int5 = 1
    Else:
        send.int5 = 0
    End If
    
    R = afPalmOS.CallApp("AppForgeSDK", DP_TEXTFONT, VarPtr(send))
    If send.ret <> 0 Then
        TextFont = True
    Else:
        TextFont = False
    End If
End Function

Public Function TextUnderline(underline As Integer) As Boolean
    Dim R As Boolean
    send.int1 = underline
    R = afPalmOS.CallApp("AppForgeSDK", DP_TEXTUNDERLINE, VarPtr(send))
    If send.ret <> 0 Then
        TextUnderline = True
    Else:
        TextUnderline = False
    End If
End Function

Public Function TextBold(bold As Boolean) As Boolean
    Dim R As Boolean
    If bold = True Then
        send.int1 = 1
    Else:
        send.int1 = 0
    End If
    R = afPalmOS.CallApp("AppForgeSDK", DP_TEXTBOLD, VarPtr(send))
    If send.ret <> 0 Then
        TextBold = True
    Else:
        TextBold = False
    End If
End Function

Public Function Text90degree(degree90 As Boolean) As Boolean
    Dim R As Boolean
    If degree90 = True Then
        send.int1 = 1
    Else:
        send.int1 = 0
    End If
    R = afPalmOS.CallApp("AppForgeSDK", DP_TEXT90DEGREE, VarPtr(send))
    If send.ret <> 0 Then
        Text90degree = True
    Else:
        Text90degree = False
    End If
End Function

Public Function TextIntensity(intensity As Integer) As Boolean
    Dim R As Boolean
    send.int1 = intensity
    R = afPalmOS.CallApp("AppForgeSDK", DP_TEXTINTENSITY, VarPtr(send))
    If send.ret <> 0 Then
        TextIntensity = True
    Else:
        TextIntensity = False
    End If
End Function

Public Function TextAlign(align As Integer) As Boolean
    Dim R As Boolean
    send.int1 = align
    R = afPalmOS.CallApp("AppForgeSDK", DP_TEXTALIGN, VarPtr(send))
    If send.ret <> 0 Then
        TextAlign = True
    Else:
        TextAlign = False
    End If
End Function

Public Function Text180degree(degree180 As Boolean) As Boolean
    Dim R As Boolean
    If degree180 = True Then
        send.int1 = 1
    Else:
        send.int1 = 0
    End If
    R = afPalmOS.CallApp("AppForgeSDK", DP_TEXT180DEGREE, VarPtr(send))
    If send.ret <> 0 Then
        Text180degree = True
    Else:
        Text180degree = False
    End If
End Function

Public Function ReadBarcode(bartext As String, timeoutsec As Integer) As Boolean
    Dim R As Boolean
    
    send.int1 = timeoutsec
    R = afPalmOS.CallApp("AppForgeSDK", DP_PRINTTEXTWRAPPED, VarPtr(send))
    If send.ret <> 0 Then
        bartext = send.str1
        ReadBarcode = True
    Else:
        ReadBarcode = False
    End If
End Function

Public Function PrintBitmap(ByVal file As String) As Boolean
    Dim R As Boolean
    send.str1 = file
    send.int1 = 0
    R = afPalmOS.CallApp("AppForgeSDK", DP_PRINTBITMAP, VarPtr(send))
    If send.ret <> 0 Then
        PrintBitmap = True
    Else:
        PrintBitmap = False
    End If
End Function

Public Function PrintBitmapNew(ByVal file As String, x As Integer, y As Integer, w As Integer, h As Integer, percents As Integer) As Boolean
    Dim R As Boolean
    send.str1 = file
    send.int1 = x
    send.int2 = y
    send.int3 = w
    send.int4 = h
    send.int5 = percents
    R = afPalmOS.CallApp("AppForgeSDK", DP_PRINTBITMAPNEW, VarPtr(send))
    If send.ret <> 0 Then
        PrintBitmapNew = True
    Else:
        PrintBitmapNew = False
    End If
End Function

Public Function REGISTER(ByVal number As String) As Boolean
    Dim R As Boolean
    send.str1 = number
    R = afPalmOS.CallApp("AppForgeSDK", DP_REGISTER, VarPtr(send))
    If send.ret <> 0 Then
        REGISTER = True
    Else:
        REGISTER = False
    End If
End Function

Public Function ExtOpenConnection(baudrate As Integer, databits As Integer, stopbits As Integer, parity As Integer) As Boolean
    Dim R As Boolean
    send.int1 = baudrate
    send.int2 = databits
    send.int3 = stopbits
    send.int4 = parity
    R = afPalmOS.CallApp("AppForgeSDK", DP_EXTOPENCONNECTION, VarPtr(send))
    If send.ret <> 0 Then
        ExtOpenConnection = True
    Else:
        ExtOpenConnection = False
    End If
End Function

Public Function ExtSendData(ByVal buf As String, length As Integer, timeout As Integer) As Boolean
    Dim R As Boolean
    send.str1 = buf
    send.int1 = length
    send.int2 = timeout
    R = afPalmOS.CallApp("AppForgeSDK", DP_EXTSENDDATA, VarPtr(send))
    If send.ret <> 0 Then
        ExtSendData = True
    Else:
        ExtSendData = False
    End If
End Function

Public Function ExtReceiveData(buf As String, length As Integer, timeout As Integer) As Integer
    Dim R As Boolean
    send.str1 = buf
    send.int1 = length
    send.int2 = timeout
    R = afPalmOS.CallApp("AppForgeSDK", DP_EXTRECEIVEDATA, VarPtr(send))
    If send.ret <> 0 Then
        buf = send.str1
        ExtReceiveData = True
    Else:
        ExtReceiveData = False
    End If
End Function

Public Function ExtReceiveDataStop(buf As String, length As Integer, timeout As Integer, stopbyte As Byte) As Integer
    Dim R As Boolean
    send.str1 = buf
    send.int1 = length
    send.int2 = timeout
    send.int3 = stopbyte
    R = afPalmOS.CallApp("AppForgeSDK", DP_EXTRECEIVEDATASTOP, VarPtr(send))
    If send.ret <> 0 Then
        buf = send.str1
        ExtReceiveDataStop = True
    Else:
        ExtReceiveDataStop = False
    End If
End Function

Public Function ExtCloseConnection() As Boolean
    Dim R As Boolean
    R = afPalmOS.CallApp("AppForgeSDK", DP_EXTCLOSECONNECTION, VarPtr(send))
    If send.ret <> 0 Then
        ExtCloseConnection = True
    Else:
        ExtCloseConnection = False
    End If
End Function

Public Function ExtGetDTR() As Boolean
    Dim R As Boolean
    R = afPalmOS.CallApp("AppForgeSDK", DP_EXTGETDTR, VarPtr(send))
    If send.ret <> 0 Then
        ExtGetDTR = True
    Else:
        ExtGetDTR = False
    End If
End Function

Public Function ExtSetDTR(dtr As Boolean) As Boolean
    Dim R As Boolean
    If dtr = True Then
        send.int1 = 1
    Else:
        send.int1 = 0
    End If
    R = afPalmOS.CallApp("AppForgeSDK", DP_EXTSETDTR, VarPtr(send))
    If send.ret <> 0 Then
        ExtSetDTR = True
    Else:
        ExtSetDTR = False
    End If
End Function

Public Function ExtGetRTS() As Boolean
    Dim R As Boolean
    R = afPalmOS.CallApp("AppForgeSDK", DP_EXTGETRTS, VarPtr(send))
    If send.ret <> 0 Then
        ExtGetRTS = True
    Else:
        ExtGetRTS = False
    End If
End Function

Public Function ExtGetCTS() As Boolean
    Dim R As Boolean
    R = afPalmOS.CallApp("AppForgeSDK", DP_EXTGETCTS, VarPtr(send))
    If send.ret <> 0 Then
        ExtGetCTS = True
    Else:
        ExtGetCTS = False
    End If
End Function

Public Function ExtGetDSR() As Boolean
    Dim R As Boolean
    R = afPalmOS.CallApp("AppForgeSDK", DP_EXTGETDSR, VarPtr(send))
    If send.ret <> 0 Then
        ExtGetDSR = True
    Else:
        ExtGetDSR = False
    End If
End Function

Public Function ExtGetBreak() As Boolean
    Dim R As Boolean
    R = afPalmOS.CallApp("AppForgeSDK", DP_EXTGETBREAK, VarPtr(send))
    If send.ret <> 0 Then
        ExtGetBreak = True
    Else:
        ExtGetBreak = False
    End If
End Function

Public Function ExtSetBreak(break As Boolean) As Boolean
    Dim R As Boolean
    If break = True Then
        send.int1 = 1
    Else:
        send.int1 = 0
    End If
    R = afPalmOS.CallApp("AppForgeSDK", DP_EXTSETBREAK, VarPtr(send))
    If send.ret <> 0 Then
        ExtSetBreak = True
    Else:
        ExtSetBreak = False
    End If
End Function

Public Function PrnStartPage(hsize As Integer, vsize As Integer) As Boolean
    Dim R As Boolean
    send.int1 = hsize
    send.int2 = vsize
    R = afPalmOS.CallApp("AppForgeSDK", DP_PRNSTARTPAGE, VarPtr(send))
    If send.ret <> 0 Then
        PrnStartPage = True
    Else:
        PrnStartPage = False
    End If
End Function

Public Function PrnClose() As Boolean
    Dim R As Boolean
    R = afPalmOS.CallApp("AppForgeSDK", DP_PRNCLOSE, VarPtr(send))
    If send.ret <> 0 Then
        PrnClose = True
    Else:
        PrnClose = False
    End If
End Function

Public Function PrnDrawBitmap(file As String, x As Integer, y As Integer) As Boolean
    Dim R As Boolean
    send.str1 = file
    send.int1 = x
    send.int2 = y
    R = afPalmOS.CallApp("AppForgeSDK", DP_PRNDRAWBITMAP, VarPtr(send))
    If send.ret <> 0 Then
        PrnDrawBitmap = True
    Else:
        PrnDrawBitmap = False
    End If
End Function

Public Function PrnDrawChars(text As String, x As Integer, y As Integer) As Boolean
    Dim R As Boolean
    send.str1 = text
    send.int1 = x
    send.int2 = y
    R = afPalmOS.CallApp("AppForgeSDK", DP_PRNDRAWCHARS, VarPtr(send))
    If send.ret <> 0 Then
        PrnDrawChars = True
    Else:
        PrnDrawChars = False
    End If
End Function

Public Function PrnDrawTruncChars(text As String, x As Integer, y As Integer, maxwidth As Integer) As Boolean
    Dim R As Boolean
    send.str1 = text
    send.int1 = x
    send.int2 = y
    send.int3 = maxwidth
    R = afPalmOS.CallApp("AppForgeSDK", DP_PRNDRAWTRUNCCHARS, VarPtr(send))
    If send.ret <> 0 Then
        PrnDrawTruncChars = True
    Else:
        PrnDrawTruncChars = False
    End If
End Function

Public Function PrnDrawGrayLine(x1 As Integer, y1 As Integer, x2 As Integer, y2 As Integer) As Boolean
    Dim R As Boolean
    send.int1 = x1
    send.int2 = y1
    send.int3 = x2
    send.int4 = y2
    R = afPalmOS.CallApp("AppForgeSDK", DP_PRNDRAWGRAYLINE, VarPtr(send))
    If send.ret <> 0 Then
        PrnDrawGrayLine = True
    Else:
        PrnDrawGrayLine = False
    End If
End Function

Public Function PrnDrawGrayRectangle(left As Integer, top As Integer, width As Integer, height As Integer, cornerdiam As Integer) As Boolean
    Dim R As Boolean
    send.int1 = left
    send.int2 = top
    send.int3 = width
    send.int4 = height
    send.int5 = cornerdiam
    R = afPalmOS.CallApp("AppForgeSDK", DP_PRNDRAWGRAYRECTANGLE, VarPtr(send))
    If send.ret <> 0 Then
        PrnDrawGrayRectangle = True
    Else:
        PrnDrawGrayRectangle = False
    End If
End Function

Public Function PrnDrawGrayRectangleFrame(left As Integer, top As Integer, width As Integer, height As Integer, cornerdiam As Integer) As Boolean
    Dim R As Boolean
    send.int1 = left
    send.int2 = top
    send.int3 = width
    send.int4 = height
    send.int5 = cornerdiam
    R = afPalmOS.CallApp("AppForgeSDK", DP_PRNDRAWGRAYRECTANGLEFRAME, VarPtr(send))
    If send.ret <> 0 Then
        PrnDrawGrayRectangleFrame = True
    Else:
        PrnDrawGrayRectangleFrame = False
    End If
End Function

Public Function PrnDrawLine(x1 As Integer, y1 As Integer, x2 As Integer, y2 As Integer) As Boolean
    Dim R As Boolean
    send.int1 = x1
    send.int2 = y1
    send.int3 = x2
    send.int4 = y2
    R = afPalmOS.CallApp("AppForgeSDK", DP_PRNDRAWLINE, VarPtr(send))
    If send.ret <> 0 Then
        PrnDrawLine = True
    Else:
        PrnDrawLine = False
    End If
End Function

Public Function PrnDrawRectangle(left As Integer, top As Integer, width As Integer, height As Integer, cornerdiam As Integer) As Boolean
    Dim R As Boolean
    send.int1 = left
    send.int2 = top
    send.int3 = width
    send.int4 = height
    send.int5 = cornerdiam
    R = afPalmOS.CallApp("AppForgeSDK", DP_PRNDRAWRECTANGLE, VarPtr(send))
    If send.ret <> 0 Then
        PrnDrawRectangle = True
    Else:
        PrnDrawRectangle = False
    End If
End Function

Public Function PrnFillRectangle(left As Integer, top As Integer, width As Integer, height As Integer, cornerdiam As Integer) As Boolean
    Dim R As Boolean
    send.int1 = left
    send.int2 = top
    send.int3 = width
    send.int4 = height
    send.int5 = cornerdiam
    R = afPalmOS.CallApp("AppForgeSDK", DP_PRNFILLRECTANGLE, VarPtr(send))
    If send.ret <> 0 Then
        PrnFillRectangle = True
    Else:
        PrnFillRectangle = False
    End If
End Function

Public Function PrnDrawRectangleFrame(left As Integer, top As Integer, width As Integer, height As Integer, cornerdiam As Integer) As Boolean
    Dim R As Boolean
    send.int1 = left
    send.int2 = top
    send.int3 = width
    send.int4 = height
    send.int5 = cornerdiam
    R = afPalmOS.CallApp("AppForgeSDK", DP_PRNDRAWRECTANGLEFRAME, VarPtr(send))
    If send.ret <> 0 Then
        PrnDrawRectangleFrame = True
    Else:
        PrnDrawRectangleFrame = False
    End If
End Function

Public Function PrnDrawText(text As String, left As Integer, top As Integer, width As Integer, height As Integer, flags As Integer) As Boolean
    Dim R As Boolean
    send.str1 = text
    send.int1 = left
    send.int2 = top
    send.int3 = width
    send.int4 = height
    send.int5 = flags
    R = afPalmOS.CallApp("AppForgeSDK", DP_PRNDRAWTEXT, VarPtr(send))
    If send.ret <> 0 Then
        PrnDrawText = True
    Else:
        PrnDrawText = False
    End If
End Function

Public Function PrnGetFont() As Integer
    Dim R As Boolean
    R = afPalmOS.CallApp("AppForgeSDK", DP_PRNGETFONT, VarPtr(send))
    If send.ret <> 0 Then
        PrnGetFont = send.int1
    Else:
        PrnGetFont = 0
    End If
End Function

Public Function PrnGetPageExtent(extentx As Integer, extenty As Integer) As Boolean
    Dim R As Boolean
    R = afPalmOS.CallApp("AppForgeSDK", DP_PRNGETPAGEEXTENT, VarPtr(send))
    If send.ret <> 0 Then
        extentx = send.int1
        extenty = send.int2
        PrnGetPageExtent = True
    Else:
        PrnGetPageExtent = False
    End If
End Function

Public Function PrnGetUnderlineMode() As Integer
    Dim R As Boolean
    R = afPalmOS.CallApp("AppForgeSDK", DP_PRNGETUNDERLINEMODE, VarPtr(send))
    If send.ret <> 0 Then
        PrnGetUnderlineMode = send.int1
    Else:
        PrnGetUnderlineMode = 0
    End If
End Function

Public Function PrnSetUnderlineMode(mode As Integer) As Boolean
    Dim R As Boolean
    
    send.int1 = mode
    R = afPalmOS.CallApp("AppForgeSDK", DP_PRNSETUNDERLINEMODE, VarPtr(send))
    If send.ret <> 0 Then
        PrnSetUnderlineMode = True
    Else:
        PrnSetUnderlineMode = False
    End If
End Function

Public Function PrnGetAverageCharWidth() As Integer
    Dim R As Boolean
    R = afPalmOS.CallApp("AppForgeSDK", DP_PRNGETAVARAGECHARWIDTH, VarPtr(send))
    If send.ret <> 0 Then
        PrnGetAverageCharWidth = send.int1
    Else:
        PrnGetAverageCharWidth = 0
    End If
End Function

Public Function PrnGetCharHeight() As Integer
    Dim R As Boolean
    R = afPalmOS.CallApp("AppForgeSDK", DP_PRNGETCHARHEIGHT, VarPtr(send))
    If send.ret <> 0 Then
        PrnGetCharHeight = send.int1
    Else:
        PrnGetCharHeight = 0
    End If
End Function

Public Function PrnGetCharWidth(ch As Byte) As Integer
    Dim R As Boolean
    send.int1 = ch
    R = afPalmOS.CallApp("AppForgeSDK", DP_PRNGETCHARWIDTH, VarPtr(send))
    If send.ret <> 0 Then
        PrnGetCharWidth = send.int1
    Else:
        PrnGetCharWidth = 0
    End If
End Function

Public Function PrnGetCharsInWidth(text As String, stringWidthP As Integer, stringLengthP As Integer, fitWithinWidth As Boolean) As Boolean
    Dim R As Boolean
    send.str1 = text
    send.int1 = stringWidthP
    send.int2 = stringLengthP
    R = afPalmOS.CallApp("AppForgeSDK", DP_PRNGETCHARSINWIDTH, VarPtr(send))
    If send.ret <> 0 Then
        stringWidthP = send.int1
        stringLengthP = send.int2
        If send.int3 = 1 Then
            fitWithinWidth = True
        Else:
            fitWithinWidth = False
        End If
        PrnGetCharsInWidth = True
    Else:
        PrnGetCharsInWidth = False
    End If
End Function

Public Function PrnGetCharsWidth(text As String) As Integer
    Dim R As Boolean
    send.str1 = text
    R = afPalmOS.CallApp("AppForgeSDK", DP_PRNGETCHARSWIDTH, VarPtr(send))
    If send.ret <> 0 Then
        PrnGetCharsWidth = send.int1
    Else:
        PrnGetCharsWidth = 0
    End If
End Function

Public Function PrnGetTextMode() As Integer
    Dim R As Boolean
    R = afPalmOS.CallApp("AppForgeSDK", DP_PRNGETTEXTMODE, VarPtr(send))
    If send.ret <> 0 Then
        PrnGetTextMode = send.int1
    Else:
        PrnGetTextMode = 0
    End If
End Function

Public Function PrnSetTextMode(mode As Integer) As Boolean
    Dim R As Boolean
    send.int1 = mode
    R = afPalmOS.CallApp("AppForgeSDK", DP_PRNSETTEXTMODE, VarPtr(send))
    If send.ret <> 0 Then
        PrnSetTextMode = True
    Else:
        PrnSetTextMode = False
    End If
End Function

Public Function PrnEndPage() As Boolean
    Dim R As Boolean
    R = afPalmOS.CallApp("AppForgeSDK", DP_PRNENDPAGE, VarPtr(send))
    If send.ret <> 0 Then
        PrnEndPage = True
    Else:
        PrnEndPage = False
    End If
End Function

Public Function PrnSetFont(font As Integer) As Boolean
    Dim R As Boolean
    
    send.int1 = font
    R = afPalmOS.CallApp("AppForgeSDK", DP_PRNSETFONT, VarPtr(send))
    If send.ret <> 0 Then
        PrnSetFont = True
    Else:
        PrnSetFont = False
    End If
End Function

Public Function ScreenInfo(width As Integer, height As Integer, depth As Integer) As Boolean
    Dim R As Boolean
    R = afPalmOS.CallApp("AppForgeSDK", DP_SCREENINFO, VarPtr(send))
    If send.ret <> 0 Then
        width = send.int1
        height = send.int2
        depth = send.int3
        ScreenInfo = True
    Else:
        ScreenInfo = False
    End If
End Function

Public Function LineFeedX(lines As Integer) As Boolean
    Dim R As Boolean
    send.int1 = lines
    R = afPalmOS.CallApp("AppForgeSDK", DP_LINEFEEDX, VarPtr(send))
    If send.ret <> 0 Then
        LineFeedX = True
    Else:
        LineFeedX = False
    End If
End Function

Public Function PPBarcodeRead(bartype As Integer, barcode As String) As Integer
    Dim R As Boolean
    
    send.str1 = "                                                                                                                                                      "
    R = afPalmOS.CallApp("AppForgeSDK", DP_PPBARCODEREAD, VarPtr(send))
    
    PPBarcodeRead = send.ret
    If send.ret = PPBarErrNone Then
        bartype = send.int1
        barcode = send.str1
    End If
End Function

Public Function GetPrinterCapabilities(num As Integer) As Integer
    Dim R As Boolean
    send.int1 = num
    R = afPalmOS.CallApp("AppForgeSDK", DP_GETPRINTERCAPABILITIES, VarPtr(send))
    
    GetPrinterCapabilities = send.ret
End Function

Public Function GetPrinterType() As Integer
    Dim R As Boolean
    R = afPalmOS.CallApp("AppForgeSDK", DP_GETPRINTERTYPE, VarPtr(send))
    
    GetPrinterType = send.ret
End Function

Public Function SetPrinterType(printer As Integer) As Boolean
    Dim R As Boolean
    send.int1 = printer
    R = afPalmOS.CallApp("AppForgeSDK", DP_SETPRINTERTYPE, VarPtr(send))
    
    If send.ret <> 0 Then
        SetPrinterType = True
    Else:
        SetPrinterType = False
    End If
End Function

Public Function GetConnectionType() As Integer
    Dim R As Boolean
    R = afPalmOS.CallApp("AppForgeSDK", DP_GETCONNECTIONTYPE, VarPtr(send))
    
    GetConnectionType = send.ret
End Function

Public Function SetConnectionType(connection As Integer) As Boolean
    Dim R As Boolean
    
    send.int1 = connection
    R = afPalmOS.CallApp("AppForgeSDK", DP_SETCONNECTIONTYPE, VarPtr(send))
    
    If send.ret <> 0 Then
        SetConnectionType = True
    Else:
        SetConnectionType = False
    End If
End Function

Public Function GetConnectionSpeed() As Integer
    Dim R As Boolean
    R = afPalmOS.CallApp("AppForgeSDK", DP_GETCONNECTIONSPEED, VarPtr(send))
    
    GetConnectionSpeed = send.ret
End Function

Public Function SetConnectionSpeed(speed As Integer) As Boolean
    Dim R As Boolean
    
    send.int1 = speed
    R = afPalmOS.CallApp("AppForgeSDK", DP_SETCONNECTIONSPEED, VarPtr(send))
    
    If send.ret <> 0 Then
        SetConnectionSpeed = True
    Else:
        SetConnectionSpeed = False
    End If
End Function

Public Function ChangePrinterSpeed(speed As Integer) As Boolean
    Dim R As Boolean
    
    send.int1 = speed
    R = afPalmOS.CallApp("AppForgeSDK", DP_CHANGEPRINTERSPEED, VarPtr(send))
    
    If send.ret <> 0 Then
        ChangePrinterSpeed = True
    Else:
        ChangePrinterSpeed = False
    End If
End Function

Public Function DetectPrinter() As Boolean
    Dim R As Boolean
    R = afPalmOS.CallApp("AppForgeSDK", DP_DETECTPRINTER, VarPtr(send))
    
    If send.ret <> 0 Then
        DetectPrinter = True
    Else:
        DetectPrinter = False
    End If
End Function

Public Function GetStatus(statcmd As Integer) As Integer
    Dim R As Boolean
    
    send.int1 = statcmd
    R = afPalmOS.CallApp("AppForgeSDK", DP_GETSTATUS, VarPtr(send))
    
    GetStatus = send.ret
End Function

Public Function SetLeftMargin(margin As Integer) As Boolean
    Dim R As Boolean
    
    send.int1 = margin
    R = afPalmOS.CallApp("AppForgeSDK", DP_SETLEFTMARGIN, VarPtr(send))
    
    If send.ret <> 0 Then
        SetLeftMargin = True
    Else:
        SetLeftMargin = False
    End If
End Function

Public Function ControlPanel(flags As Integer) As Boolean
    Dim R As Boolean
    
    send.int1 = flags
    R = afPalmOS.CallApp("AppForgeSDK", DP_CONTROLPANEL, VarPtr(send))
    
    If send.ret <> 0 Then
        ControlPanel = True
    Else:
        ControlPanel = False
    End If
End Function

Public Function ResetDefaults(flags As Integer) As Boolean
    Dim R As Boolean
    
    send.int1 = flags
    R = afPalmOS.CallApp("AppForgeSDK", DP_RESETDEFAULTS, VarPtr(send))
    
    If send.ret <> 0 Then
        ResetDefaults = True
    Else:
        ResetDefaults = False
    End If
End Function

Public Function SetLineSpace(linespace As Integer) As Boolean
    Dim R As Boolean
    
    send.int1 = linespace
    R = afPalmOS.CallApp("AppForgeSDK", DP_SETLINESPACE, VarPtr(send))
    
    If send.ret <> 0 Then
        SetLineSpace = True
    Else:
        SetLineSpace = False
    End If
End Function

Public Function SetFontDoubleHeight(doubleheight As Boolean) As Boolean
    Dim R As Boolean
    
    If doubleheight = True Then
        send.int1 = 1
    Else:
        send.int1 = 0
    End If
    
    R = afPalmOS.CallApp("AppForgeSDK", DP_SETFONTDOUBLEHEIGHT, VarPtr(send))
    
    If send.ret <> 0 Then
        SetFontDoubleHeight = True
    Else:
        SetFontDoubleHeight = False
    End If
End Function

Public Function SetFontDoubleWidth(doublewidth As Boolean) As Boolean
    Dim R As Boolean
    
    If doublewidth = True Then
        send.int1 = 1
    Else:
        send.int1 = 0
    End If
    
    R = afPalmOS.CallApp("AppForgeSDK", DP_SETFONTDOUBLEWIDTH, VarPtr(send))
    
    If send.ret <> 0 Then
        SetFontDoubleWidth = True
    Else:
        SetFontDoubleWidth = False
    End If
End Function

Public Function PrintTextEx(text As String, flags As Integer) As Boolean
    Dim R As Boolean
    
    send.str1 = text
    send.int1 = flags
    R = afPalmOS.CallApp("AppForgeSDK", DP_PRINTTEXTEX, VarPtr(send))
    
    If send.ret <> 0 Then
        PrintTextEx = True
    Else:
        PrintTextEx = False
    End If
End Function

Public Function SetItalic(italic As Boolean) As Boolean
    Dim R As Boolean
    
    If italic = True Then
        send.int1 = 1
    Else:
        send.int1 = 0
    End If
    
    R = afPalmOS.CallApp("AppForgeSDK", DP_SETITALIC, VarPtr(send))
    
    If send.ret <> 0 Then
        SetItalic = True
    Else:
        SetItalic = False
    End If
End Function

Public Function SetRowBorders(border As Integer, symbol As String) As Boolean
    Dim R As Boolean
    
    send.int1 = border
    send.str1 = symbol
    R = afPalmOS.CallApp("AppForgeSDK", DP_SETROWBORDERS, VarPtr(send))
    
    If send.ret <> 0 Then
        SetRowBorders = True
    Else:
        SetRowBorders = False
    End If
End Function

Public Function LoadCustomBorderSet(setid As Integer) As Boolean
    Dim R As Boolean
    
    send.int1 = setid
    R = afPalmOS.CallApp("AppForgeSDK", DP_LOADCUSTOMBORDERSET, VarPtr(send))
    
    If send.ret <> 0 Then
        LoadCustomBorderSet = True
    Else:
        LoadCustomBorderSet = False
    End If
End Function

Public Function StartTable(flags As Integer) As Boolean
    Dim R As Boolean
    
    send.int1 = flags
    R = afPalmOS.CallApp("AppForgeSDK", DP_STARTTABLE, VarPtr(send))
    
    If send.ret <> 0 Then
        StartTable = True
    Else:
        StartTable = False
    End If
End Function

Public Function StartRow(ncolumns As Integer, flags As Integer) As Boolean
    Dim R As Boolean
    
    send.int1 = ncolumns
    send.int2 = flags
    R = afPalmOS.CallApp("AppForgeSDK", DP_STARTROW, VarPtr(send))
    
    If send.ret <> 0 Then
        StartRow = True
    Else:
        StartRow = False
    End If
End Function

Public Function SetCol(colindex As Integer, length As Integer, flags As Integer) As Boolean
    Dim R As Boolean
    
    send.int1 = colindex
    send.int2 = length
    send.int3 = flags
    R = afPalmOS.CallApp("AppForgeSDK", DP_SETCOL, VarPtr(send))
    
    If send.ret <> 0 Then
        SetCol = True
    Else:
        SetCol = False
    End If
End Function

Public Function FillCol(colindex As Integer, text As String) As Boolean
    Dim R As Boolean
    
    send.int1 = colindex
    send.str1 = text
    R = afPalmOS.CallApp("AppForgeSDK", DP_FILLCOL, VarPtr(send))
    
    If send.ret <> 0 Then
        FillCol = True
    Else:
        FillCol = False
    End If
End Function

Public Function EndRow() As Boolean
    Dim R As Boolean
    
    R = afPalmOS.CallApp("AppForgeSDK", DP_ENDROW, VarPtr(send))
    
    If send.ret <> 0 Then
        EndRow = True
    Else:
        EndRow = False
    End If
End Function

Public Function EndTable() As Boolean
    Dim R As Boolean
    
    R = afPalmOS.CallApp("AppForgeSDK", DP_ENDTABLE, VarPtr(send))
    
    If send.ret <> 0 Then
        EndTable = True
    Else:
        EndTable = False
    End If
End Function

Public Function FillColInt(colindex As Integer, num As Integer, minlen As Integer) As Boolean
    Dim R As Boolean
    
    send.int1 = colindex
    send.int2 = num
    send.int3 = minlen
    R = afPalmOS.CallApp("AppForgeSDK", DP_FILLCOLINT, VarPtr(send))
    
    If send.ret <> 0 Then
        FillColInt = True
    Else:
        FillColInt = False
    End If
End Function

Public Function FillColDouble(colindex As Integer, num As Double, round As Integer, minlen As Integer) As Boolean
    Dim R As Boolean
    
    send.int1 = colindex
    send.dbl1 = num
    send.int2 = round
    send.int3 = minlen
    R = afPalmOS.CallApp("AppForgeSDK", DP_FILLCOLDOUBLE, VarPtr(send))
    
    If send.ret <> 0 Then
        FillColDouble = True
    Else:
        FillColDouble = False
    End If
End Function

Public Function GetROMSerialNumber(buffer As String) As Boolean
    Dim R As Boolean
    
    R = afPalmOS.CallApp("AppForgeSDK", DP_GETROMSERIALNUMBER, VarPtr(send))
    
    If send.ret <> 0 Then
        buffer = send.str1
        GetROMSerialNumber = True
    Else:
        GetROMSerialNumber = False
    End If
End Function

Public Function BarcodeType2Text(bartype As Integer) As String
    Dim R As Boolean
    
    send.int1 = bartype
    send.str1 = "                                                                                                                                                      "
    R = afPalmOS.CallApp("AppForgeSDK", DP_BARCODETYPE2TEXT, VarPtr(send))
    
    If send.ret <> 0 Then
        BarcodeType2Text = send.str1
    Else:
        BarcodeType2Text = ""
    End If
End Function

Public Function GetLibraryInfo(param As Integer) As Integer
    Dim R As Boolean
    
    send.int1 = param
    R = afPalmOS.CallApp("AppForgeSDK", DP_GETLIBRARYINFO, VarPtr(send))
    
    GetLibraryInfo = send.ret
End Function

Public Function PPBarcodeGetParam(param As Integer) As Integer
    Dim R As Boolean
    
    send.int1 = param
    R = afPalmOS.CallApp("AppForgeSDK", DP_PPBARCODEGETPARAM, VarPtr(send))
    
    PPBarcodeGetParam = send.ret
End Function

Public Function PPBarcodeSetParam(param As Integer, val As Integer) As Boolean
    Dim R As Boolean
    
    send.int1 = param
    send.int2 = val
    R = afPalmOS.CallApp("AppForgeSDK", DP_PPBARCODESETPARAM, VarPtr(send))
    
    If send.ret <> 0 Then
        PPBarcodeSetParam = True
    Else:
        PPBarcodeSetParam = False
    End If
End Function

Public Function PPBarcodeControlPanel(flags As Integer) As Boolean
    Dim R As Boolean
    
    send.int1 = flags
    R = afPalmOS.CallApp("AppForgeSDK", DP_PPBARCODECONTROLPANEL, VarPtr(send))
    
    If send.ret <> 0 Then
        PPBarcodeControlPanel = True
    Else:
        PPBarcodeControlPanel = False
    End If
End Function

