Unit PocketStudioSDK;

Interface

uses PalmOS, Bitmap;

const LibCreator = Rsc('DSDK');
const sysLibTrapCustom=sysLibTrapBase +5;
// ----------------------------------------------------------------------------
// shared library routines

function  DPSDK_InitPrinter(RefNum: UInt16):Boolean; external sysLibTrapCustom;
procedure DPSDK_DonePrinter(RefNum: UInt16);external sysLibTrapCustom + 1;
procedure DPSDK_LineFeed(RefNum: UInt16);external sysLibTrapCustom + 2;
function  DPSDK_SelfTest(RefNum: UInt16; longtest:Boolean):Boolean; external sysLibTrapCustom + 3;
function  DPSDK_PrintText(RefNum: UInt16; const text:PChar):Boolean; external sysLibTrapCustom + 4;
function  DPSDK_PrintTextWrapped(RefNum: UInt16; text:PChar):Boolean; external sysLibTrapCustom + 5;
function  DPSDK_PrintBarcode(RefNum: UInt16; BarType:UInt16; barcode:PChar):Boolean; external sysLibTrapCustom + 6;
function  DPSDK_PrintBuffer(RefNum: UInt16; buf:PChar; size:UInt16):Boolean; external sysLibTrapCustom + 7;
function  DPSDK_PrintImage(RefNum: UInt16; x:UInt16; y:UInt16; image:PChar):Boolean; external sysLibTrapCustom + 8;
function  DPSDK_PrintLogo(RefNum: UInt16; m:UInt8):Boolean; external sysLibTrapCustom + 9;
function  DPSDK_PrintScreen(RefNum: UInt16; X:UInt16; Y:UInt16; W:UInt16; H:UInt16; percents:UInt16):Boolean; external sysLibTrapCustom + 10;
procedure DPSDK_SetAlign(RefNum: UInt16; align:UInt16);external sysLibTrapCustom + 11;
procedure DPSDK_SetAutoLineFeed(RefNum: UInt16; LF:Boolean);external sysLibTrapCustom + 12;
procedure DPSDK_SetBold(RefNum: UInt16; bold:Boolean);external sysLibTrapCustom + 13;
procedure DPSDK_SetBarcodeScale(RefNum: UInt16; scale:UInt16);external sysLibTrapCustom + 14;
procedure DPSDK_SetBarcodeHeight(RefNum: UInt16; height:UInt16);external sysLibTrapCustom + 15;
procedure DPSDK_SetBarcodeText(RefNum: UInt16; text:UInt16);external sysLibTrapCustom + 16;
procedure DPSDK_SetIntensity(RefNum: UInt16; Intensity:UInt16);external sysLibTrapCustom + 17;
procedure DPSDK_SetFont(RefNum: UInt16; fnt:UInt16);external sysLibTrapCustom + 18;
procedure DPSDK_SetUnderline(RefNum: UInt16; underline:Boolean);external sysLibTrapCustom + 19;
procedure DPSDK_Set90degree(RefNum: UInt16; R:Boolean);external sysLibTrapCustom + 20;
procedure DPSDK_SetReverse(RefNum: UInt16; R:Boolean);external sysLibTrapCustom + 21;
function  DPSDK_GetLastError(refNum:UInt16):UInt16; external sysLibTrapCustom + 22;
function  DPSDK_GetBattery(refNum:UInt16):UInt16; external sysLibTrapCustom + 23;
function  DPSDK_GetTemperature(refNum:UInt16):UInt16; external sysLibTrapCustom + 24;
function  DPSDK_ReadPaymentCard(RefNum: UInt16; Name:PChar; sizeN:UInt16; Number:PChar; sizeD:UInt16; year:Pointer; month:Pointer; timeout:UInt16):Boolean; external sysLibTrapCustom + 26;
function  DPSDK_UploadLogo(RefNum: UInt16;  cardId:UInt16; name:PChar):Boolean; external sysLibTrapCustom + 27;
procedure DPSDK_TextStart(refNum:UInt16);external sysLibTrapCustom + 28;
procedure DPSDK_TextEnd(refNum:UInt16);external sysLibTrapCustom + 29;
procedure DPSDK_TextOut(RefNum: UInt16; text:PChar);external sysLibTrapCustom + 30;
procedure DPSDK_TextOutN(RefNum: UInt16; text:PChar; size:UInt16);external sysLibTrapCustom + 31;
procedure DPSDK_TextCharSpace (RefNum: UInt16; Space:UInt8);external sysLibTrapCustom + 32;
procedure DPSDK_TextFont(RefNum: UInt16; big:UInt8; bold:UInt8; doubleheight:UInt8; doublewidth:UInt8; underline:UInt8);external sysLibTrapCustom + 33;
procedure DPSDK_TextUnderline (RefNum: UInt16; Underline:UInt8);external sysLibTrapCustom + 34;
procedure DPSDK_TextBold (RefNum: UInt16; Bold:UInt8);external sysLibTrapCustom + 35;
procedure DPSDK_Text90degree (RefNum: UInt16; Degree:UInt8);external sysLibTrapCustom + 36;
procedure DPSDK_TextIntensity (RefNum: UInt16; Intesity:UInt8);external sysLibTrapCustom + 37;
procedure DPSDK_TextAlign (RefNum: UInt16; Align:UInt8);external sysLibTrapCustom + 38;
procedure DPSDK_Text180degree (RefNum: UInt16; Degree:UInt8);external sysLibTrapCustom + 39;
function  DPSDK_GetRelease (refNum:UInt16):UInt16; external sysLibTrapCustom + 40;
function  DPSDK_PrintBarcodeN(RefNum: UInt16; BarType:UInt16; barcode:PChar; N:UInt8):Boolean; external sysLibTrapCustom + 41;
function  DPSDK_GetPrintererVersion(refNum:UInt16):UInt16; external sysLibTrapCustom + 42;
function  DPSDK_ReadCardTracks(RefNum: UInt16; Track1:PChar; Track2:PChar; Track3:PChar; timeout:UInt16):Boolean; external sysLibTrapCustom + 43;
procedure DPSDK_SetBarcodeAlign(RefNum: UInt16; align:UInt16);external sysLibTrapCustom + 44;
function  DPSDK_PrintBitmapRes(RefNum: UInt16; ResID:UInt16):Boolean; external sysLibTrapCustom + 45;
function  DPSDK_PrintBitmapPtr(RefNum: UInt16; Bmp:BitmapPtr):Boolean; external sysLibTrapCustom + 46;
function  DPSDK_IsInitialized(refNum:UInt16):Boolean; external sysLibTrapCustom + 47;
function  DPSDK_ReadBarcode(RefNum: UInt16; timeout:UInt16; buf:PChar; size:UInt16):Boolean; external sysLibTrapCustom + 48;
procedure DPSDK_SetImageSettings(RefNum: UInt16; BrightEnabled:Boolean; Brightness:UInt16; ContrastEnabled:Boolean; Contrast:UInt16);external sysLibTrapCustom + 49;
function  DPSDK_ScreenCapture(RefNum: UInt16; X:UInt16; Y:UInt16; W:UInt16; H:UInt16; percents:UInt16; buffer:PChar):Boolean; external sysLibTrapCustom + 50;
function  DPSDK_ReadCardTracksStart(RefNum: UInt16; Track1:PChar; Track2:PChar; Track3:PChar; timeout:UInt16):Boolean; external sysLibTrapCustom + 52;
function  DPSDK_ReadCardResult(RefNum: UInt16; Stop:Boolean):Boolean; external sysLibTrapCustom + 53;
function  DPSDK_ReadPaymentCardStart(RefNum: UInt16; Name:PChar; sizeN:UInt16; Number:PChar; sizeD:UInt16; year:Pointer; month:Pointer; timeout:UInt16):Boolean; external sysLibTrapCustom + 54;

implementation

procedure TestLibrary(ProcID: UInt16);
var MyLibrary: UInt16;
begin
  if SysLibLoad(sysFileTLibrary, LibCreator, MyLibrary) <> 0 then
  begin
//    FrmAlert(AlertLibrary);
    Exit;
  end;

//  case ProcID of
//    1: Beep(MyLibrary, sndAlarm);
//    2: Alert(MyLibrary, AlertAbout);
//  end;

  SysLibRemove(MyLibrary);
end;

end.